// Code generated by girgen. DO NOT EDIT.

package atk

import (
	"runtime"
	"unsafe"

	coreglib "github.com/diamondburned/gotk4/pkg/core/glib"
)

// #include <stdlib.h>
// #include <atk/atk.h>
// #include <glib-object.h>
// void _gotk4_atk1_EditableText_virtual_copy_text(void* fnptr, AtkEditableText* arg0, gint arg1, gint arg2) {
//   ((void (*)(AtkEditableText*, gint, gint))(fnptr))(arg0, arg1, arg2);
// };
// void _gotk4_atk1_EditableText_virtual_cut_text(void* fnptr, AtkEditableText* arg0, gint arg1, gint arg2) {
//   ((void (*)(AtkEditableText*, gint, gint))(fnptr))(arg0, arg1, arg2);
// };
// void _gotk4_atk1_EditableText_virtual_delete_text(void* fnptr, AtkEditableText* arg0, gint arg1, gint arg2) {
//   ((void (*)(AtkEditableText*, gint, gint))(fnptr))(arg0, arg1, arg2);
// };
// void _gotk4_atk1_EditableText_virtual_insert_text(void* fnptr, AtkEditableText* arg0, gchar* arg1, gint arg2, gint* arg3) {
//   ((void (*)(AtkEditableText*, gchar*, gint, gint*))(fnptr))(arg0, arg1, arg2, arg3);
// };
// void _gotk4_atk1_EditableText_virtual_paste_text(void* fnptr, AtkEditableText* arg0, gint arg1) {
//   ((void (*)(AtkEditableText*, gint))(fnptr))(arg0, arg1);
// };
// void _gotk4_atk1_EditableText_virtual_set_text_contents(void* fnptr, AtkEditableText* arg0, gchar* arg1) {
//   ((void (*)(AtkEditableText*, gchar*))(fnptr))(arg0, arg1);
// };
import "C"

// GType values.
var (
	GTypeEditableText = coreglib.Type(C.atk_editable_text_get_type())
)

func init() {
	coreglib.RegisterGValueMarshalers([]coreglib.TypeMarshaler{
		coreglib.TypeMarshaler{T: GTypeEditableText, F: marshalEditableText},
	})
}

// EditableText should be implemented by UI components which contain text which
// the user can edit, via the Object corresponding to that component (see
// Object).
//
// EditableText is a subclass of Text, and as such, an object which implements
// EditableText is by definition an Text implementor as well.
//
// See also: Text.
//
// EditableText wraps an interface. This means the user can get the
// underlying type by calling Cast().
type EditableText struct {
	_ [0]func() // equal guard
	*coreglib.Object
}

var (
	_ coreglib.Objector = (*EditableText)(nil)
)

// EditableTexter describes EditableText's interface methods.
type EditableTexter interface {
	coreglib.Objector

	// CopyText: copy text from start_pos up to, but not including end_pos to
	// the clipboard.
	CopyText(startPos, endPos int)
	// CutText: copy text from start_pos up to, but not including end_pos to the
	// clipboard and then delete from the widget.
	CutText(startPos, endPos int)
	// DeleteText: delete text start_pos up to, but not including end_pos.
	DeleteText(startPos, endPos int)
	// InsertText: insert text at a given position.
	InsertText(str string, length int, position *int)
	// PasteText: paste text from clipboard to specified position.
	PasteText(position int)
	// SetTextContents: set text contents of text.
	SetTextContents(str string)
}

var _ EditableTexter = (*EditableText)(nil)

func wrapEditableText(obj *coreglib.Object) *EditableText {
	return &EditableText{
		Object: obj,
	}
}

func marshalEditableText(p uintptr) (interface{}, error) {
	return wrapEditableText(coreglib.ValueFromNative(unsafe.Pointer(p)).Object()), nil
}

// CopyText: copy text from start_pos up to, but not including end_pos to the
// clipboard.
//
// The function takes the following parameters:
//
//    - startPos: start position.
//    - endPos: end position.
//
func (text *EditableText) CopyText(startPos, endPos int) {
	var _arg0 *C.AtkEditableText // out
	var _arg1 C.gint             // out
	var _arg2 C.gint             // out

	_arg0 = (*C.AtkEditableText)(unsafe.Pointer(coreglib.InternObject(text).Native()))
	_arg1 = C.gint(startPos)
	_arg2 = C.gint(endPos)

	C.atk_editable_text_copy_text(_arg0, _arg1, _arg2)
	runtime.KeepAlive(text)
	runtime.KeepAlive(startPos)
	runtime.KeepAlive(endPos)
}

// CutText: copy text from start_pos up to, but not including end_pos to the
// clipboard and then delete from the widget.
//
// The function takes the following parameters:
//
//    - startPos: start position.
//    - endPos: end position.
//
func (text *EditableText) CutText(startPos, endPos int) {
	var _arg0 *C.AtkEditableText // out
	var _arg1 C.gint             // out
	var _arg2 C.gint             // out

	_arg0 = (*C.AtkEditableText)(unsafe.Pointer(coreglib.InternObject(text).Native()))
	_arg1 = C.gint(startPos)
	_arg2 = C.gint(endPos)

	C.atk_editable_text_cut_text(_arg0, _arg1, _arg2)
	runtime.KeepAlive(text)
	runtime.KeepAlive(startPos)
	runtime.KeepAlive(endPos)
}

// DeleteText: delete text start_pos up to, but not including end_pos.
//
// The function takes the following parameters:
//
//    - startPos: start position.
//    - endPos: end position.
//
func (text *EditableText) DeleteText(startPos, endPos int) {
	var _arg0 *C.AtkEditableText // out
	var _arg1 C.gint             // out
	var _arg2 C.gint             // out

	_arg0 = (*C.AtkEditableText)(unsafe.Pointer(coreglib.InternObject(text).Native()))
	_arg1 = C.gint(startPos)
	_arg2 = C.gint(endPos)

	C.atk_editable_text_delete_text(_arg0, _arg1, _arg2)
	runtime.KeepAlive(text)
	runtime.KeepAlive(startPos)
	runtime.KeepAlive(endPos)
}

// InsertText: insert text at a given position.
//
// The function takes the following parameters:
//
//    - str: text to insert.
//    - length of text to insert, in bytes.
//    - position: caller initializes this to the position at which to insert the
//      text. After the call it points at the position after the newly inserted
//      text.
//
func (text *EditableText) InsertText(str string, length int, position *int) {
	var _arg0 *C.AtkEditableText // out
	var _arg1 *C.gchar           // out
	var _arg2 C.gint             // out
	var _arg3 *C.gint            // out

	_arg0 = (*C.AtkEditableText)(unsafe.Pointer(coreglib.InternObject(text).Native()))
	_arg1 = (*C.gchar)(unsafe.Pointer(C.CString(str)))
	defer C.free(unsafe.Pointer(_arg1))
	_arg2 = C.gint(length)
	_arg3 = (*C.gint)(unsafe.Pointer(position))

	C.atk_editable_text_insert_text(_arg0, _arg1, _arg2, _arg3)
	runtime.KeepAlive(text)
	runtime.KeepAlive(str)
	runtime.KeepAlive(length)
	runtime.KeepAlive(position)
}

// PasteText: paste text from clipboard to specified position.
//
// The function takes the following parameters:
//
//    - position to paste.
//
func (text *EditableText) PasteText(position int) {
	var _arg0 *C.AtkEditableText // out
	var _arg1 C.gint             // out

	_arg0 = (*C.AtkEditableText)(unsafe.Pointer(coreglib.InternObject(text).Native()))
	_arg1 = C.gint(position)

	C.atk_editable_text_paste_text(_arg0, _arg1)
	runtime.KeepAlive(text)
	runtime.KeepAlive(position)
}

// SetTextContents: set text contents of text.
//
// The function takes the following parameters:
//
//    - str: string to set for text contents of text.
//
func (text *EditableText) SetTextContents(str string) {
	var _arg0 *C.AtkEditableText // out
	var _arg1 *C.gchar           // out

	_arg0 = (*C.AtkEditableText)(unsafe.Pointer(coreglib.InternObject(text).Native()))
	_arg1 = (*C.gchar)(unsafe.Pointer(C.CString(str)))
	defer C.free(unsafe.Pointer(_arg1))

	C.atk_editable_text_set_text_contents(_arg0, _arg1)
	runtime.KeepAlive(text)
	runtime.KeepAlive(str)
}

// copyText: copy text from start_pos up to, but not including end_pos to the
// clipboard.
//
// The function takes the following parameters:
//
//    - startPos: start position.
//    - endPos: end position.
//
func (text *EditableText) copyText(startPos, endPos int) {
	gclass := (*C.AtkEditableTextIface)(coreglib.PeekParentClass(text))
	fnarg := gclass.copy_text

	var _arg0 *C.AtkEditableText // out
	var _arg1 C.gint             // out
	var _arg2 C.gint             // out

	_arg0 = (*C.AtkEditableText)(unsafe.Pointer(coreglib.InternObject(text).Native()))
	_arg1 = C.gint(startPos)
	_arg2 = C.gint(endPos)

	C._gotk4_atk1_EditableText_virtual_copy_text(unsafe.Pointer(fnarg), _arg0, _arg1, _arg2)
	runtime.KeepAlive(text)
	runtime.KeepAlive(startPos)
	runtime.KeepAlive(endPos)
}

// cutText: copy text from start_pos up to, but not including end_pos to the
// clipboard and then delete from the widget.
//
// The function takes the following parameters:
//
//    - startPos: start position.
//    - endPos: end position.
//
func (text *EditableText) cutText(startPos, endPos int) {
	gclass := (*C.AtkEditableTextIface)(coreglib.PeekParentClass(text))
	fnarg := gclass.cut_text

	var _arg0 *C.AtkEditableText // out
	var _arg1 C.gint             // out
	var _arg2 C.gint             // out

	_arg0 = (*C.AtkEditableText)(unsafe.Pointer(coreglib.InternObject(text).Native()))
	_arg1 = C.gint(startPos)
	_arg2 = C.gint(endPos)

	C._gotk4_atk1_EditableText_virtual_cut_text(unsafe.Pointer(fnarg), _arg0, _arg1, _arg2)
	runtime.KeepAlive(text)
	runtime.KeepAlive(startPos)
	runtime.KeepAlive(endPos)
}

// deleteText: delete text start_pos up to, but not including end_pos.
//
// The function takes the following parameters:
//
//    - startPos: start position.
//    - endPos: end position.
//
func (text *EditableText) deleteText(startPos, endPos int) {
	gclass := (*C.AtkEditableTextIface)(coreglib.PeekParentClass(text))
	fnarg := gclass.delete_text

	var _arg0 *C.AtkEditableText // out
	var _arg1 C.gint             // out
	var _arg2 C.gint             // out

	_arg0 = (*C.AtkEditableText)(unsafe.Pointer(coreglib.InternObject(text).Native()))
	_arg1 = C.gint(startPos)
	_arg2 = C.gint(endPos)

	C._gotk4_atk1_EditableText_virtual_delete_text(unsafe.Pointer(fnarg), _arg0, _arg1, _arg2)
	runtime.KeepAlive(text)
	runtime.KeepAlive(startPos)
	runtime.KeepAlive(endPos)
}

// insertText: insert text at a given position.
//
// The function takes the following parameters:
//
//    - str: text to insert.
//    - length of text to insert, in bytes.
//    - position: caller initializes this to the position at which to insert the
//      text. After the call it points at the position after the newly inserted
//      text.
//
func (text *EditableText) insertText(str string, length int, position *int) {
	gclass := (*C.AtkEditableTextIface)(coreglib.PeekParentClass(text))
	fnarg := gclass.insert_text

	var _arg0 *C.AtkEditableText // out
	var _arg1 *C.gchar           // out
	var _arg2 C.gint             // out
	var _arg3 *C.gint            // out

	_arg0 = (*C.AtkEditableText)(unsafe.Pointer(coreglib.InternObject(text).Native()))
	_arg1 = (*C.gchar)(unsafe.Pointer(C.CString(str)))
	defer C.free(unsafe.Pointer(_arg1))
	_arg2 = C.gint(length)
	_arg3 = (*C.gint)(unsafe.Pointer(position))

	C._gotk4_atk1_EditableText_virtual_insert_text(unsafe.Pointer(fnarg), _arg0, _arg1, _arg2, _arg3)
	runtime.KeepAlive(text)
	runtime.KeepAlive(str)
	runtime.KeepAlive(length)
	runtime.KeepAlive(position)
}

// pasteText: paste text from clipboard to specified position.
//
// The function takes the following parameters:
//
//    - position to paste.
//
func (text *EditableText) pasteText(position int) {
	gclass := (*C.AtkEditableTextIface)(coreglib.PeekParentClass(text))
	fnarg := gclass.paste_text

	var _arg0 *C.AtkEditableText // out
	var _arg1 C.gint             // out

	_arg0 = (*C.AtkEditableText)(unsafe.Pointer(coreglib.InternObject(text).Native()))
	_arg1 = C.gint(position)

	C._gotk4_atk1_EditableText_virtual_paste_text(unsafe.Pointer(fnarg), _arg0, _arg1)
	runtime.KeepAlive(text)
	runtime.KeepAlive(position)
}

// setTextContents: set text contents of text.
//
// The function takes the following parameters:
//
//    - str: string to set for text contents of text.
//
func (text *EditableText) setTextContents(str string) {
	gclass := (*C.AtkEditableTextIface)(coreglib.PeekParentClass(text))
	fnarg := gclass.set_text_contents

	var _arg0 *C.AtkEditableText // out
	var _arg1 *C.gchar           // out

	_arg0 = (*C.AtkEditableText)(unsafe.Pointer(coreglib.InternObject(text).Native()))
	_arg1 = (*C.gchar)(unsafe.Pointer(C.CString(str)))
	defer C.free(unsafe.Pointer(_arg1))

	C._gotk4_atk1_EditableText_virtual_set_text_contents(unsafe.Pointer(fnarg), _arg0, _arg1)
	runtime.KeepAlive(text)
	runtime.KeepAlive(str)
}

// EditableTextIface: instance of this type is always passed by reference.
type EditableTextIface struct {
	*editableTextIface
}

// editableTextIface is the struct that's finalized.
type editableTextIface struct {
	native *C.AtkEditableTextIface
}
