// Code generated by girgen. DO NOT EDIT.

package gtk

import (
	"runtime"
	"unsafe"

	"github.com/diamondburned/gotk4/pkg/core/gextras"
	coreglib "github.com/diamondburned/gotk4/pkg/core/glib"
	"github.com/diamondburned/gotk4/pkg/gio/v2"
)

// #include <stdlib.h>
// #include <glib-object.h>
// #include <gtk/gtk-a11y.h>
// #include <gtk/gtk.h>
// #include <gtk/gtkx.h>
// extern void _gotk4_gtk3_Action_ConnectActivate(gpointer, guintptr);
// extern void _gotk4_gtk3_ActionClass_disconnect_proxy(GtkAction*, GtkWidget*);
// extern void _gotk4_gtk3_ActionClass_connect_proxy(GtkAction*, GtkWidget*);
// extern void _gotk4_gtk3_ActionClass_activate(GtkAction*);
// extern GtkWidget* _gotk4_gtk3_ActionClass_create_tool_item(GtkAction*);
// extern GtkWidget* _gotk4_gtk3_ActionClass_create_menu_item(GtkAction*);
// extern GtkWidget* _gotk4_gtk3_ActionClass_create_menu(GtkAction*);
// GtkWidget* _gotk4_gtk3_Action_virtual_create_menu(void* fnptr, GtkAction* arg0) {
//   return ((GtkWidget* (*)(GtkAction*))(fnptr))(arg0);
// };
// GtkWidget* _gotk4_gtk3_Action_virtual_create_menu_item(void* fnptr, GtkAction* arg0) {
//   return ((GtkWidget* (*)(GtkAction*))(fnptr))(arg0);
// };
// GtkWidget* _gotk4_gtk3_Action_virtual_create_tool_item(void* fnptr, GtkAction* arg0) {
//   return ((GtkWidget* (*)(GtkAction*))(fnptr))(arg0);
// };
// void _gotk4_gtk3_Action_virtual_activate(void* fnptr, GtkAction* arg0) {
//   ((void (*)(GtkAction*))(fnptr))(arg0);
// };
// void _gotk4_gtk3_Action_virtual_connect_proxy(void* fnptr, GtkAction* arg0, GtkWidget* arg1) {
//   ((void (*)(GtkAction*, GtkWidget*))(fnptr))(arg0, arg1);
// };
// void _gotk4_gtk3_Action_virtual_disconnect_proxy(void* fnptr, GtkAction* arg0, GtkWidget* arg1) {
//   ((void (*)(GtkAction*, GtkWidget*))(fnptr))(arg0, arg1);
// };
import "C"

// GType values.
var (
	GTypeAction = coreglib.Type(C.gtk_action_get_type())
)

func init() {
	coreglib.RegisterGValueMarshalers([]coreglib.TypeMarshaler{
		coreglib.TypeMarshaler{T: GTypeAction, F: marshalAction},
	})
}

// ActionOverrides contains methods that are overridable.
type ActionOverrides struct {
	// Activate emits the “activate” signal on the specified action, if it isn't
	// insensitive. This gets called by the proxy widgets when they get
	// activated.
	//
	// It can also be used to manually activate an action.
	//
	// Deprecated: Use g_action_group_activate_action() on a #GAction instead.
	Activate func()
	// The function takes the following parameters:
	//
	ConnectProxy func(proxy Widgetter)
	// CreateMenu: if action provides a Menu widget as a submenu for the menu
	// item or the toolbar item it creates, this function returns an instance of
	// that menu.
	//
	// Deprecated: Use #GAction and Model instead, and create a Menu with
	// gtk_menu_new_from_model().
	//
	// The function returns the following values:
	//
	//    - widget: menu item provided by the action, or NULL.
	//
	CreateMenu func() Widgetter
	// CreateMenuItem creates a menu item widget that proxies for the given
	// action.
	//
	// Deprecated: Use g_menu_item_new() and associate it with a #GAction
	// instead.
	//
	// The function returns the following values:
	//
	//    - widget: menu item connected to the action.
	//
	CreateMenuItem func() Widgetter
	// CreateToolItem creates a toolbar item widget that proxies for the given
	// action.
	//
	// Deprecated: Use a ToolItem and associate it with a #GAction using
	// gtk_actionable_set_action_name() instead.
	//
	// The function returns the following values:
	//
	//    - widget: toolbar item connected to the action.
	//
	CreateToolItem func() Widgetter
	// The function takes the following parameters:
	//
	DisconnectProxy func(proxy Widgetter)
}

func defaultActionOverrides(v *Action) ActionOverrides {
	return ActionOverrides{
		Activate:        v.activate,
		ConnectProxy:    v.connectProxy,
		CreateMenu:      v.createMenu,
		CreateMenuItem:  v.createMenuItem,
		CreateToolItem:  v.createToolItem,
		DisconnectProxy: v.disconnectProxy,
	}
}

// Action: > In GTK+ 3.10, GtkAction has been deprecated. Use #GAction >
// instead, and associate actions with Actionable widgets. Use > Model for
// creating menus with gtk_menu_new_from_model().
//
// Actions represent operations that the user can be perform, along with some
// information how it should be presented in the interface. Each action provides
// methods to create icons, menu items and toolbar items representing itself.
//
// As well as the callback that is called when the action gets activated, the
// following also gets associated with the action:
//
// - a name (not translated, for path lookup)
//
// - a label (translated, for display)
//
// - an accelerator
//
// - whether label indicates a stock id
//
// - a tooltip (optional, translated)
//
// - a toolbar label (optional, shorter than label)
//
//    The action will also have some state information:
//
// - visible (shown/hidden)
//
// - sensitive (enabled/disabled)
//
// Apart from regular actions, there are [toggle actions][GtkToggleAction],
// which can be toggled between two states and [radio actions][GtkRadioAction],
// of which only one in a group can be in the “active” state. Other actions can
// be implemented as Action subclasses.
//
// Each action can have one or more proxy widgets. To act as an action proxy,
// widget needs to implement Activatable interface. Proxies mirror the state of
// the action and should change when the action’s state changes. Properties that
// are always mirrored by proxies are Action:sensitive and Action:visible.
// Action:gicon, Action:icon-name, Action:label, Action:short-label and
// Action:stock-id properties are only mirorred if proxy widget has
// Activatable:use-action-appearance property set to TRUE.
//
// When the proxy is activated, it should activate its action.
type Action struct {
	_ [0]func() // equal guard
	*coreglib.Object

	Buildable
}

var (
	_ coreglib.Objector = (*Action)(nil)
)

func init() {
	coreglib.RegisterClassInfo[*Action, *ActionClass, ActionOverrides](
		GTypeAction,
		initActionClass,
		wrapAction,
		defaultActionOverrides,
	)
}

func initActionClass(gclass unsafe.Pointer, overrides ActionOverrides, classInitFunc func(*ActionClass)) {
	pclass := (*C.GtkActionClass)(unsafe.Pointer(C.g_type_check_class_cast((*C.GTypeClass)(gclass), C.GType(GTypeAction))))

	if overrides.Activate != nil {
		pclass.activate = (*[0]byte)(C._gotk4_gtk3_ActionClass_activate)
	}

	if overrides.ConnectProxy != nil {
		pclass.connect_proxy = (*[0]byte)(C._gotk4_gtk3_ActionClass_connect_proxy)
	}

	if overrides.CreateMenu != nil {
		pclass.create_menu = (*[0]byte)(C._gotk4_gtk3_ActionClass_create_menu)
	}

	if overrides.CreateMenuItem != nil {
		pclass.create_menu_item = (*[0]byte)(C._gotk4_gtk3_ActionClass_create_menu_item)
	}

	if overrides.CreateToolItem != nil {
		pclass.create_tool_item = (*[0]byte)(C._gotk4_gtk3_ActionClass_create_tool_item)
	}

	if overrides.DisconnectProxy != nil {
		pclass.disconnect_proxy = (*[0]byte)(C._gotk4_gtk3_ActionClass_disconnect_proxy)
	}

	if classInitFunc != nil {
		class := (*ActionClass)(gextras.NewStructNative(gclass))
		classInitFunc(class)
	}
}

func wrapAction(obj *coreglib.Object) *Action {
	return &Action{
		Object: obj,
		Buildable: Buildable{
			Object: obj,
		},
	}
}

func marshalAction(p uintptr) (interface{}, error) {
	return wrapAction(coreglib.ValueFromNative(unsafe.Pointer(p)).Object()), nil
}

// ConnectActivate: "activate" signal is emitted when the action is activated.
func (action *Action) ConnectActivate(f func()) coreglib.SignalHandle {
	return coreglib.ConnectGeneratedClosure(action, "activate", false, unsafe.Pointer(C._gotk4_gtk3_Action_ConnectActivate), f)
}

// NewAction creates a new Action object. To add the action to a ActionGroup and
// set the accelerator for the action, call
// gtk_action_group_add_action_with_accel(). See the [UI Definition
// section][XML-UI] for information on allowed action names.
//
// Deprecated: Use #GAction instead, associating it to a widget with Actionable
// or creating a Menu with gtk_menu_new_from_model().
//
// The function takes the following parameters:
//
//    - name: unique name for the action.
//    - label (optional) displayed in menu items and on buttons, or NULL.
//    - tooltip (optional) for the action, or NULL.
//    - stockId (optional): stock icon to display in widgets representing the
//      action, or NULL.
//
// The function returns the following values:
//
//    - action: new Action.
//
func NewAction(name, label, tooltip, stockId string) *Action {
	var _arg1 *C.gchar     // out
	var _arg2 *C.gchar     // out
	var _arg3 *C.gchar     // out
	var _arg4 *C.gchar     // out
	var _cret *C.GtkAction // in

	_arg1 = (*C.gchar)(unsafe.Pointer(C.CString(name)))
	defer C.free(unsafe.Pointer(_arg1))
	if label != "" {
		_arg2 = (*C.gchar)(unsafe.Pointer(C.CString(label)))
		defer C.free(unsafe.Pointer(_arg2))
	}
	if tooltip != "" {
		_arg3 = (*C.gchar)(unsafe.Pointer(C.CString(tooltip)))
		defer C.free(unsafe.Pointer(_arg3))
	}
	if stockId != "" {
		_arg4 = (*C.gchar)(unsafe.Pointer(C.CString(stockId)))
		defer C.free(unsafe.Pointer(_arg4))
	}

	_cret = C.gtk_action_new(_arg1, _arg2, _arg3, _arg4)
	runtime.KeepAlive(name)
	runtime.KeepAlive(label)
	runtime.KeepAlive(tooltip)
	runtime.KeepAlive(stockId)

	var _action *Action // out

	_action = wrapAction(coreglib.AssumeOwnership(unsafe.Pointer(_cret)))

	return _action
}

// Activate emits the “activate” signal on the specified action, if it isn't
// insensitive. This gets called by the proxy widgets when they get activated.
//
// It can also be used to manually activate an action.
//
// Deprecated: Use g_action_group_activate_action() on a #GAction instead.
func (action *Action) Activate() {
	var _arg0 *C.GtkAction // out

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))

	C.gtk_action_activate(_arg0)
	runtime.KeepAlive(action)
}

// BlockActivate: disable activation signals from the action
//
// This is needed when updating the state of your proxy Activatable widget could
// result in calling gtk_action_activate(), this is a convenience function to
// avoid recursing in those cases (updating toggle state for instance).
//
// Deprecated: Use g_simple_action_set_enabled() to disable the Action instead.
func (action *Action) BlockActivate() {
	var _arg0 *C.GtkAction // out

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))

	C.gtk_action_block_activate(_arg0)
	runtime.KeepAlive(action)
}

// ConnectAccelerator installs the accelerator for action if action has an accel
// path and group. See gtk_action_set_accel_path() and
// gtk_action_set_accel_group()
//
// Since multiple proxies may independently trigger the installation of the
// accelerator, the action counts the number of times this function has been
// called and doesn’t remove the accelerator until
// gtk_action_disconnect_accelerator() has been called as many times.
//
// Deprecated: Use #GAction and the accelerator group on an associated Menu
// instead.
func (action *Action) ConnectAccelerator() {
	var _arg0 *C.GtkAction // out

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))

	C.gtk_action_connect_accelerator(_arg0)
	runtime.KeepAlive(action)
}

// CreateIcon: this function is intended for use by action implementations to
// create icons displayed in the proxy widgets.
//
// Deprecated: Use g_menu_item_set_icon() to set an icon on a Item, or
// gtk_container_add() to add a Image to a Button.
//
// The function takes the following parameters:
//
//    - iconSize: size of the icon (IconSize) that should be created.
//
// The function returns the following values:
//
//    - widget that displays the icon for this action.
//
func (action *Action) CreateIcon(iconSize int) Widgetter {
	var _arg0 *C.GtkAction  // out
	var _arg1 C.GtkIconSize // out
	var _cret *C.GtkWidget  // in

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))
	_arg1 = C.GtkIconSize(iconSize)

	_cret = C.gtk_action_create_icon(_arg0, _arg1)
	runtime.KeepAlive(action)
	runtime.KeepAlive(iconSize)

	var _widget Widgetter // out

	{
		objptr := unsafe.Pointer(_cret)
		if objptr == nil {
			panic("object of type gtk.Widgetter is nil")
		}

		object := coreglib.Take(objptr)
		casted := object.WalkCast(func(obj coreglib.Objector) bool {
			_, ok := obj.(Widgetter)
			return ok
		})
		rv, ok := casted.(Widgetter)
		if !ok {
			panic("no marshaler for " + object.TypeFromInstance().String() + " matching gtk.Widgetter")
		}
		_widget = rv
	}

	return _widget
}

// CreateMenu: if action provides a Menu widget as a submenu for the menu item
// or the toolbar item it creates, this function returns an instance of that
// menu.
//
// Deprecated: Use #GAction and Model instead, and create a Menu with
// gtk_menu_new_from_model().
//
// The function returns the following values:
//
//    - widget: menu item provided by the action, or NULL.
//
func (action *Action) CreateMenu() Widgetter {
	var _arg0 *C.GtkAction // out
	var _cret *C.GtkWidget // in

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))

	_cret = C.gtk_action_create_menu(_arg0)
	runtime.KeepAlive(action)

	var _widget Widgetter // out

	{
		objptr := unsafe.Pointer(_cret)
		if objptr == nil {
			panic("object of type gtk.Widgetter is nil")
		}

		object := coreglib.Take(objptr)
		casted := object.WalkCast(func(obj coreglib.Objector) bool {
			_, ok := obj.(Widgetter)
			return ok
		})
		rv, ok := casted.(Widgetter)
		if !ok {
			panic("no marshaler for " + object.TypeFromInstance().String() + " matching gtk.Widgetter")
		}
		_widget = rv
	}

	return _widget
}

// CreateMenuItem creates a menu item widget that proxies for the given action.
//
// Deprecated: Use g_menu_item_new() and associate it with a #GAction instead.
//
// The function returns the following values:
//
//    - widget: menu item connected to the action.
//
func (action *Action) CreateMenuItem() Widgetter {
	var _arg0 *C.GtkAction // out
	var _cret *C.GtkWidget // in

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))

	_cret = C.gtk_action_create_menu_item(_arg0)
	runtime.KeepAlive(action)

	var _widget Widgetter // out

	{
		objptr := unsafe.Pointer(_cret)
		if objptr == nil {
			panic("object of type gtk.Widgetter is nil")
		}

		object := coreglib.Take(objptr)
		casted := object.WalkCast(func(obj coreglib.Objector) bool {
			_, ok := obj.(Widgetter)
			return ok
		})
		rv, ok := casted.(Widgetter)
		if !ok {
			panic("no marshaler for " + object.TypeFromInstance().String() + " matching gtk.Widgetter")
		}
		_widget = rv
	}

	return _widget
}

// CreateToolItem creates a toolbar item widget that proxies for the given
// action.
//
// Deprecated: Use a ToolItem and associate it with a #GAction using
// gtk_actionable_set_action_name() instead.
//
// The function returns the following values:
//
//    - widget: toolbar item connected to the action.
//
func (action *Action) CreateToolItem() Widgetter {
	var _arg0 *C.GtkAction // out
	var _cret *C.GtkWidget // in

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))

	_cret = C.gtk_action_create_tool_item(_arg0)
	runtime.KeepAlive(action)

	var _widget Widgetter // out

	{
		objptr := unsafe.Pointer(_cret)
		if objptr == nil {
			panic("object of type gtk.Widgetter is nil")
		}

		object := coreglib.Take(objptr)
		casted := object.WalkCast(func(obj coreglib.Objector) bool {
			_, ok := obj.(Widgetter)
			return ok
		})
		rv, ok := casted.(Widgetter)
		if !ok {
			panic("no marshaler for " + object.TypeFromInstance().String() + " matching gtk.Widgetter")
		}
		_widget = rv
	}

	return _widget
}

// DisconnectAccelerator undoes the effect of one call to
// gtk_action_connect_accelerator().
//
// Deprecated: Use #GAction and the accelerator group on an associated Menu
// instead.
func (action *Action) DisconnectAccelerator() {
	var _arg0 *C.GtkAction // out

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))

	C.gtk_action_disconnect_accelerator(_arg0)
	runtime.KeepAlive(action)
}

// AccelPath returns the accel path for this action.
//
// Deprecated: Use #GAction and the accelerator path on an associated Menu
// instead.
//
// The function returns the following values:
//
//    - utf8: accel path for this action, or NULL if none is set. The returned
//      string is owned by GTK+ and must not be freed or modified.
//
func (action *Action) AccelPath() string {
	var _arg0 *C.GtkAction // out
	var _cret *C.gchar     // in

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))

	_cret = C.gtk_action_get_accel_path(_arg0)
	runtime.KeepAlive(action)

	var _utf8 string // out

	_utf8 = C.GoString((*C.gchar)(unsafe.Pointer(_cret)))

	return _utf8
}

// AlwaysShowImage returns whether action's menu item proxies will always show
// their image, if available.
//
// Deprecated: Use g_menu_item_get_attribute_value() on a Item instead.
//
// The function returns the following values:
//
//    - ok: TRUE if the menu item proxies will always show their image.
//
func (action *Action) AlwaysShowImage() bool {
	var _arg0 *C.GtkAction // out
	var _cret C.gboolean   // in

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))

	_cret = C.gtk_action_get_always_show_image(_arg0)
	runtime.KeepAlive(action)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// GIcon gets the gicon of action.
//
// Deprecated: Use #GAction instead, and g_menu_item_get_attribute_value() to
// get an icon from a Item associated with a #GAction.
//
// The function returns the following values:
//
//    - icon action’s #GIcon if one is set.
//
func (action *Action) GIcon() *gio.Icon {
	var _arg0 *C.GtkAction // out
	var _cret *C.GIcon     // in

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))

	_cret = C.gtk_action_get_gicon(_arg0)
	runtime.KeepAlive(action)

	var _icon *gio.Icon // out

	{
		obj := coreglib.Take(unsafe.Pointer(_cret))
		_icon = &gio.Icon{
			Object: obj,
		}
	}

	return _icon
}

// IconName gets the icon name of action.
//
// Deprecated: Use #GAction instead, and g_menu_item_get_attribute_value() to
// get an icon from a Item associated with a #GAction.
//
// The function returns the following values:
//
//    - utf8: icon name.
//
func (action *Action) IconName() string {
	var _arg0 *C.GtkAction // out
	var _cret *C.gchar     // in

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))

	_cret = C.gtk_action_get_icon_name(_arg0)
	runtime.KeepAlive(action)

	var _utf8 string // out

	_utf8 = C.GoString((*C.gchar)(unsafe.Pointer(_cret)))

	return _utf8
}

// IsImportant checks whether action is important or not
//
// Deprecated: Use #GAction instead, and control and monitor whether labels are
// shown directly.
//
// The function returns the following values:
//
//    - ok: whether action is important.
//
func (action *Action) IsImportant() bool {
	var _arg0 *C.GtkAction // out
	var _cret C.gboolean   // in

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))

	_cret = C.gtk_action_get_is_important(_arg0)
	runtime.KeepAlive(action)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// Label gets the label text of action.
//
// Deprecated: Use #GAction instead, and get a label from a menu item with
// g_menu_item_get_attribute_value(). For Actionable widgets, use the
// widget-specific API to get a label.
//
// The function returns the following values:
//
//    - utf8: label text.
//
func (action *Action) Label() string {
	var _arg0 *C.GtkAction // out
	var _cret *C.gchar     // in

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))

	_cret = C.gtk_action_get_label(_arg0)
	runtime.KeepAlive(action)

	var _utf8 string // out

	_utf8 = C.GoString((*C.gchar)(unsafe.Pointer(_cret)))

	return _utf8
}

// Name returns the name of the action.
//
// Deprecated: Use g_action_get_name() on a #GAction instead.
//
// The function returns the following values:
//
//    - utf8: name of the action. The string belongs to GTK+ and should not be
//      freed.
//
func (action *Action) Name() string {
	var _arg0 *C.GtkAction // out
	var _cret *C.gchar     // in

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))

	_cret = C.gtk_action_get_name(_arg0)
	runtime.KeepAlive(action)

	var _utf8 string // out

	_utf8 = C.GoString((*C.gchar)(unsafe.Pointer(_cret)))

	return _utf8
}

// Proxies returns the proxy widgets for an action. See also
// gtk_activatable_get_related_action().
//
// Deprecated: since version 3.10.
//
// The function returns the following values:
//
//    - sList of proxy widgets. The list is owned by GTK+ and must not be
//      modified.
//
func (action *Action) Proxies() []Widgetter {
	var _arg0 *C.GtkAction // out
	var _cret *C.GSList    // in

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))

	_cret = C.gtk_action_get_proxies(_arg0)
	runtime.KeepAlive(action)

	var _sList []Widgetter // out

	_sList = make([]Widgetter, 0, gextras.SListSize(unsafe.Pointer(_cret)))
	gextras.MoveSList(unsafe.Pointer(_cret), false, func(v unsafe.Pointer) {
		src := (*C.GtkWidget)(v)
		var dst Widgetter // out
		{
			objptr := unsafe.Pointer(src)
			if objptr == nil {
				panic("object of type gtk.Widgetter is nil")
			}

			object := coreglib.Take(objptr)
			casted := object.WalkCast(func(obj coreglib.Objector) bool {
				_, ok := obj.(Widgetter)
				return ok
			})
			rv, ok := casted.(Widgetter)
			if !ok {
				panic("no marshaler for " + object.TypeFromInstance().String() + " matching gtk.Widgetter")
			}
			dst = rv
		}
		_sList = append(_sList, dst)
	})

	return _sList
}

// Sensitive returns whether the action itself is sensitive. Note that this
// doesn’t necessarily mean effective sensitivity. See gtk_action_is_sensitive()
// for that.
//
// Deprecated: Use g_action_get_enabled() on a #GAction instead.
//
// The function returns the following values:
//
//    - ok: TRUE if the action itself is sensitive.
//
func (action *Action) Sensitive() bool {
	var _arg0 *C.GtkAction // out
	var _cret C.gboolean   // in

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))

	_cret = C.gtk_action_get_sensitive(_arg0)
	runtime.KeepAlive(action)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// ShortLabel gets the short label text of action.
//
// Deprecated: Use #GAction instead, which has no equivalent of short labels.
//
// The function returns the following values:
//
//    - utf8: short label text.
//
func (action *Action) ShortLabel() string {
	var _arg0 *C.GtkAction // out
	var _cret *C.gchar     // in

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))

	_cret = C.gtk_action_get_short_label(_arg0)
	runtime.KeepAlive(action)

	var _utf8 string // out

	_utf8 = C.GoString((*C.gchar)(unsafe.Pointer(_cret)))

	return _utf8
}

// StockID gets the stock id of action.
//
// Deprecated: Use #GAction instead, which has no equivalent of stock items.
//
// The function returns the following values:
//
//    - utf8: stock id.
//
func (action *Action) StockID() string {
	var _arg0 *C.GtkAction // out
	var _cret *C.gchar     // in

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))

	_cret = C.gtk_action_get_stock_id(_arg0)
	runtime.KeepAlive(action)

	var _utf8 string // out

	_utf8 = C.GoString((*C.gchar)(unsafe.Pointer(_cret)))

	return _utf8
}

// Tooltip gets the tooltip text of action.
//
// Deprecated: Use #GAction instead, and get tooltips from associated Actionable
// widgets with gtk_widget_get_tooltip_text().
//
// The function returns the following values:
//
//    - utf8: tooltip text.
//
func (action *Action) Tooltip() string {
	var _arg0 *C.GtkAction // out
	var _cret *C.gchar     // in

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))

	_cret = C.gtk_action_get_tooltip(_arg0)
	runtime.KeepAlive(action)

	var _utf8 string // out

	_utf8 = C.GoString((*C.gchar)(unsafe.Pointer(_cret)))

	return _utf8
}

// Visible returns whether the action itself is visible. Note that this doesn’t
// necessarily mean effective visibility. See gtk_action_is_sensitive() for
// that.
//
// Deprecated: Use #GAction instead, and control and monitor the state of
// Actionable widgets directly.
//
// The function returns the following values:
//
//    - ok: TRUE if the action itself is visible.
//
func (action *Action) Visible() bool {
	var _arg0 *C.GtkAction // out
	var _cret C.gboolean   // in

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))

	_cret = C.gtk_action_get_visible(_arg0)
	runtime.KeepAlive(action)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// VisibleHorizontal checks whether action is visible when horizontal
//
// Deprecated: Use #GAction instead, and control and monitor the visibility of
// associated widgets and menu items directly.
//
// The function returns the following values:
//
//    - ok: whether action is visible when horizontal.
//
func (action *Action) VisibleHorizontal() bool {
	var _arg0 *C.GtkAction // out
	var _cret C.gboolean   // in

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))

	_cret = C.gtk_action_get_visible_horizontal(_arg0)
	runtime.KeepAlive(action)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// VisibleVertical checks whether action is visible when horizontal
//
// Deprecated: Use #GAction instead, and control and monitor the visibility of
// associated widgets and menu items directly.
//
// The function returns the following values:
//
//    - ok: whether action is visible when horizontal.
//
func (action *Action) VisibleVertical() bool {
	var _arg0 *C.GtkAction // out
	var _cret C.gboolean   // in

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))

	_cret = C.gtk_action_get_visible_vertical(_arg0)
	runtime.KeepAlive(action)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// IsSensitive returns whether the action is effectively sensitive.
//
// Deprecated: Use g_action_get_enabled() on a #GAction instead.
//
// The function returns the following values:
//
//    - ok: TRUE if the action and its associated action group are both
//      sensitive.
//
func (action *Action) IsSensitive() bool {
	var _arg0 *C.GtkAction // out
	var _cret C.gboolean   // in

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))

	_cret = C.gtk_action_is_sensitive(_arg0)
	runtime.KeepAlive(action)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// IsVisible returns whether the action is effectively visible.
//
// Deprecated: Use #GAction instead, and control and monitor the state of
// Actionable widgets directly.
//
// The function returns the following values:
//
//    - ok: TRUE if the action and its associated action group are both visible.
//
func (action *Action) IsVisible() bool {
	var _arg0 *C.GtkAction // out
	var _cret C.gboolean   // in

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))

	_cret = C.gtk_action_is_visible(_arg0)
	runtime.KeepAlive(action)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// SetAccelGroup sets the AccelGroup in which the accelerator for this action
// will be installed.
//
// Deprecated: Use #GAction and the accelerator group on an associated Menu
// instead.
//
// The function takes the following parameters:
//
//    - accelGroup (optional) or NULL.
//
func (action *Action) SetAccelGroup(accelGroup *AccelGroup) {
	var _arg0 *C.GtkAction     // out
	var _arg1 *C.GtkAccelGroup // out

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))
	if accelGroup != nil {
		_arg1 = (*C.GtkAccelGroup)(unsafe.Pointer(coreglib.InternObject(accelGroup).Native()))
	}

	C.gtk_action_set_accel_group(_arg0, _arg1)
	runtime.KeepAlive(action)
	runtime.KeepAlive(accelGroup)
}

// SetAccelPath sets the accel path for this action. All proxy widgets
// associated with the action will have this accel path, so that their
// accelerators are consistent.
//
// Note that accel_path string will be stored in a #GQuark. Therefore, if you
// pass a static string, you can save some memory by interning it first with
// g_intern_static_string().
//
// Deprecated: Use #GAction and the accelerator path on an associated Menu
// instead.
//
// The function takes the following parameters:
//
//    - accelPath: accelerator path.
//
func (action *Action) SetAccelPath(accelPath string) {
	var _arg0 *C.GtkAction // out
	var _arg1 *C.gchar     // out

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))
	_arg1 = (*C.gchar)(unsafe.Pointer(C.CString(accelPath)))
	defer C.free(unsafe.Pointer(_arg1))

	C.gtk_action_set_accel_path(_arg0, _arg1)
	runtime.KeepAlive(action)
	runtime.KeepAlive(accelPath)
}

// SetAlwaysShowImage sets whether action's menu item proxies will ignore the
// Settings:gtk-menu-images setting and always show their image, if available.
//
// Use this if the menu item would be useless or hard to use without their
// image.
//
// Deprecated: Use g_menu_item_set_icon() on a Item instead, if the item should
// have an image.
//
// The function takes the following parameters:
//
//    - alwaysShow: TRUE if menuitem proxies should always show their image.
//
func (action *Action) SetAlwaysShowImage(alwaysShow bool) {
	var _arg0 *C.GtkAction // out
	var _arg1 C.gboolean   // out

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))
	if alwaysShow {
		_arg1 = C.TRUE
	}

	C.gtk_action_set_always_show_image(_arg0, _arg1)
	runtime.KeepAlive(action)
	runtime.KeepAlive(alwaysShow)
}

// SetGIcon sets the icon of action.
//
// Deprecated: Use #GAction instead, and g_menu_item_set_icon() to set an icon
// on a Item associated with a #GAction, or gtk_container_add() to add a Image
// to a Button.
//
// The function takes the following parameters:
//
//    - icon to set.
//
func (action *Action) SetGIcon(icon gio.Iconner) {
	var _arg0 *C.GtkAction // out
	var _arg1 *C.GIcon     // out

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))
	_arg1 = (*C.GIcon)(unsafe.Pointer(coreglib.InternObject(icon).Native()))

	C.gtk_action_set_gicon(_arg0, _arg1)
	runtime.KeepAlive(action)
	runtime.KeepAlive(icon)
}

// SetIconName sets the icon name on action
//
// Deprecated: Use #GAction instead, and g_menu_item_set_icon() to set an icon
// on a Item associated with a #GAction, or gtk_container_add() to add a Image
// to a Button.
//
// The function takes the following parameters:
//
//    - iconName: icon name to set.
//
func (action *Action) SetIconName(iconName string) {
	var _arg0 *C.GtkAction // out
	var _arg1 *C.gchar     // out

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))
	_arg1 = (*C.gchar)(unsafe.Pointer(C.CString(iconName)))
	defer C.free(unsafe.Pointer(_arg1))

	C.gtk_action_set_icon_name(_arg0, _arg1)
	runtime.KeepAlive(action)
	runtime.KeepAlive(iconName)
}

// SetIsImportant sets whether the action is important, this attribute is used
// primarily by toolbar items to decide whether to show a label or not.
//
// Deprecated: Use #GAction instead, and control and monitor whether labels are
// shown directly.
//
// The function takes the following parameters:
//
//    - isImportant: TRUE to make the action important.
//
func (action *Action) SetIsImportant(isImportant bool) {
	var _arg0 *C.GtkAction // out
	var _arg1 C.gboolean   // out

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))
	if isImportant {
		_arg1 = C.TRUE
	}

	C.gtk_action_set_is_important(_arg0, _arg1)
	runtime.KeepAlive(action)
	runtime.KeepAlive(isImportant)
}

// SetLabel sets the label of action.
//
// Deprecated: Use #GAction instead, and set a label on a menu item with
// g_menu_item_set_label(). For Actionable widgets, use the widget-specific API
// to set a label.
//
// The function takes the following parameters:
//
//    - label text to set.
//
func (action *Action) SetLabel(label string) {
	var _arg0 *C.GtkAction // out
	var _arg1 *C.gchar     // out

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))
	_arg1 = (*C.gchar)(unsafe.Pointer(C.CString(label)))
	defer C.free(unsafe.Pointer(_arg1))

	C.gtk_action_set_label(_arg0, _arg1)
	runtime.KeepAlive(action)
	runtime.KeepAlive(label)
}

// SetSensitive sets the :sensitive property of the action to sensitive. Note
// that this doesn’t necessarily mean effective sensitivity. See
// gtk_action_is_sensitive() for that.
//
// Deprecated: Use g_simple_action_set_enabled() on a Action instead.
//
// The function takes the following parameters:
//
//    - sensitive: TRUE to make the action sensitive.
//
func (action *Action) SetSensitive(sensitive bool) {
	var _arg0 *C.GtkAction // out
	var _arg1 C.gboolean   // out

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))
	if sensitive {
		_arg1 = C.TRUE
	}

	C.gtk_action_set_sensitive(_arg0, _arg1)
	runtime.KeepAlive(action)
	runtime.KeepAlive(sensitive)
}

// SetShortLabel sets a shorter label text on action.
//
// Deprecated: Use #GAction instead, which has no equivalent of short labels.
//
// The function takes the following parameters:
//
//    - shortLabel: label text to set.
//
func (action *Action) SetShortLabel(shortLabel string) {
	var _arg0 *C.GtkAction // out
	var _arg1 *C.gchar     // out

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))
	_arg1 = (*C.gchar)(unsafe.Pointer(C.CString(shortLabel)))
	defer C.free(unsafe.Pointer(_arg1))

	C.gtk_action_set_short_label(_arg0, _arg1)
	runtime.KeepAlive(action)
	runtime.KeepAlive(shortLabel)
}

// SetStockID sets the stock id on action
//
// Deprecated: Use #GAction instead, which has no equivalent of stock items.
//
// The function takes the following parameters:
//
//    - stockId: stock id.
//
func (action *Action) SetStockID(stockId string) {
	var _arg0 *C.GtkAction // out
	var _arg1 *C.gchar     // out

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))
	_arg1 = (*C.gchar)(unsafe.Pointer(C.CString(stockId)))
	defer C.free(unsafe.Pointer(_arg1))

	C.gtk_action_set_stock_id(_arg0, _arg1)
	runtime.KeepAlive(action)
	runtime.KeepAlive(stockId)
}

// SetTooltip sets the tooltip text on action
//
// Deprecated: Use #GAction instead, and set tooltips on associated Actionable
// widgets with gtk_widget_set_tooltip_text().
//
// The function takes the following parameters:
//
//    - tooltip text.
//
func (action *Action) SetTooltip(tooltip string) {
	var _arg0 *C.GtkAction // out
	var _arg1 *C.gchar     // out

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))
	_arg1 = (*C.gchar)(unsafe.Pointer(C.CString(tooltip)))
	defer C.free(unsafe.Pointer(_arg1))

	C.gtk_action_set_tooltip(_arg0, _arg1)
	runtime.KeepAlive(action)
	runtime.KeepAlive(tooltip)
}

// SetVisible sets the :visible property of the action to visible. Note that
// this doesn’t necessarily mean effective visibility. See
// gtk_action_is_visible() for that.
//
// Deprecated: Use #GAction instead, and control and monitor the state of
// Actionable widgets directly.
//
// The function takes the following parameters:
//
//    - visible: TRUE to make the action visible.
//
func (action *Action) SetVisible(visible bool) {
	var _arg0 *C.GtkAction // out
	var _arg1 C.gboolean   // out

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))
	if visible {
		_arg1 = C.TRUE
	}

	C.gtk_action_set_visible(_arg0, _arg1)
	runtime.KeepAlive(action)
	runtime.KeepAlive(visible)
}

// SetVisibleHorizontal sets whether action is visible when horizontal
//
// Deprecated: Use #GAction instead, and control and monitor the visibility of
// associated widgets and menu items directly.
//
// The function takes the following parameters:
//
//    - visibleHorizontal: whether the action is visible horizontally.
//
func (action *Action) SetVisibleHorizontal(visibleHorizontal bool) {
	var _arg0 *C.GtkAction // out
	var _arg1 C.gboolean   // out

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))
	if visibleHorizontal {
		_arg1 = C.TRUE
	}

	C.gtk_action_set_visible_horizontal(_arg0, _arg1)
	runtime.KeepAlive(action)
	runtime.KeepAlive(visibleHorizontal)
}

// SetVisibleVertical sets whether action is visible when vertical
//
// Deprecated: Use #GAction instead, and control and monitor the visibility of
// associated widgets and menu items directly.
//
// The function takes the following parameters:
//
//    - visibleVertical: whether the action is visible vertically.
//
func (action *Action) SetVisibleVertical(visibleVertical bool) {
	var _arg0 *C.GtkAction // out
	var _arg1 C.gboolean   // out

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))
	if visibleVertical {
		_arg1 = C.TRUE
	}

	C.gtk_action_set_visible_vertical(_arg0, _arg1)
	runtime.KeepAlive(action)
	runtime.KeepAlive(visibleVertical)
}

// UnblockActivate: reenable activation signals from the action
//
// Deprecated: Use g_simple_action_set_enabled() to enable the Action instead.
func (action *Action) UnblockActivate() {
	var _arg0 *C.GtkAction // out

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))

	C.gtk_action_unblock_activate(_arg0)
	runtime.KeepAlive(action)
}

// Activate emits the “activate” signal on the specified action, if it isn't
// insensitive. This gets called by the proxy widgets when they get activated.
//
// It can also be used to manually activate an action.
//
// Deprecated: Use g_action_group_activate_action() on a #GAction instead.
func (action *Action) activate() {
	gclass := (*C.GtkActionClass)(coreglib.PeekParentClass(action))
	fnarg := gclass.activate

	var _arg0 *C.GtkAction // out

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))

	C._gotk4_gtk3_Action_virtual_activate(unsafe.Pointer(fnarg), _arg0)
	runtime.KeepAlive(action)
}

// The function takes the following parameters:
//
func (action *Action) connectProxy(proxy Widgetter) {
	gclass := (*C.GtkActionClass)(coreglib.PeekParentClass(action))
	fnarg := gclass.connect_proxy

	var _arg0 *C.GtkAction // out
	var _arg1 *C.GtkWidget // out

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))
	_arg1 = (*C.GtkWidget)(unsafe.Pointer(coreglib.InternObject(proxy).Native()))

	C._gotk4_gtk3_Action_virtual_connect_proxy(unsafe.Pointer(fnarg), _arg0, _arg1)
	runtime.KeepAlive(action)
	runtime.KeepAlive(proxy)
}

// createMenu: if action provides a Menu widget as a submenu for the menu item
// or the toolbar item it creates, this function returns an instance of that
// menu.
//
// Deprecated: Use #GAction and Model instead, and create a Menu with
// gtk_menu_new_from_model().
//
// The function returns the following values:
//
//    - widget: menu item provided by the action, or NULL.
//
func (action *Action) createMenu() Widgetter {
	gclass := (*C.GtkActionClass)(coreglib.PeekParentClass(action))
	fnarg := gclass.create_menu

	var _arg0 *C.GtkAction // out
	var _cret *C.GtkWidget // in

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))

	_cret = C._gotk4_gtk3_Action_virtual_create_menu(unsafe.Pointer(fnarg), _arg0)
	runtime.KeepAlive(action)

	var _widget Widgetter // out

	{
		objptr := unsafe.Pointer(_cret)
		if objptr == nil {
			panic("object of type gtk.Widgetter is nil")
		}

		object := coreglib.Take(objptr)
		casted := object.WalkCast(func(obj coreglib.Objector) bool {
			_, ok := obj.(Widgetter)
			return ok
		})
		rv, ok := casted.(Widgetter)
		if !ok {
			panic("no marshaler for " + object.TypeFromInstance().String() + " matching gtk.Widgetter")
		}
		_widget = rv
	}

	return _widget
}

// createMenuItem creates a menu item widget that proxies for the given action.
//
// Deprecated: Use g_menu_item_new() and associate it with a #GAction instead.
//
// The function returns the following values:
//
//    - widget: menu item connected to the action.
//
func (action *Action) createMenuItem() Widgetter {
	gclass := (*C.GtkActionClass)(coreglib.PeekParentClass(action))
	fnarg := gclass.create_menu_item

	var _arg0 *C.GtkAction // out
	var _cret *C.GtkWidget // in

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))

	_cret = C._gotk4_gtk3_Action_virtual_create_menu_item(unsafe.Pointer(fnarg), _arg0)
	runtime.KeepAlive(action)

	var _widget Widgetter // out

	{
		objptr := unsafe.Pointer(_cret)
		if objptr == nil {
			panic("object of type gtk.Widgetter is nil")
		}

		object := coreglib.Take(objptr)
		casted := object.WalkCast(func(obj coreglib.Objector) bool {
			_, ok := obj.(Widgetter)
			return ok
		})
		rv, ok := casted.(Widgetter)
		if !ok {
			panic("no marshaler for " + object.TypeFromInstance().String() + " matching gtk.Widgetter")
		}
		_widget = rv
	}

	return _widget
}

// createToolItem creates a toolbar item widget that proxies for the given
// action.
//
// Deprecated: Use a ToolItem and associate it with a #GAction using
// gtk_actionable_set_action_name() instead.
//
// The function returns the following values:
//
//    - widget: toolbar item connected to the action.
//
func (action *Action) createToolItem() Widgetter {
	gclass := (*C.GtkActionClass)(coreglib.PeekParentClass(action))
	fnarg := gclass.create_tool_item

	var _arg0 *C.GtkAction // out
	var _cret *C.GtkWidget // in

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))

	_cret = C._gotk4_gtk3_Action_virtual_create_tool_item(unsafe.Pointer(fnarg), _arg0)
	runtime.KeepAlive(action)

	var _widget Widgetter // out

	{
		objptr := unsafe.Pointer(_cret)
		if objptr == nil {
			panic("object of type gtk.Widgetter is nil")
		}

		object := coreglib.Take(objptr)
		casted := object.WalkCast(func(obj coreglib.Objector) bool {
			_, ok := obj.(Widgetter)
			return ok
		})
		rv, ok := casted.(Widgetter)
		if !ok {
			panic("no marshaler for " + object.TypeFromInstance().String() + " matching gtk.Widgetter")
		}
		_widget = rv
	}

	return _widget
}

// The function takes the following parameters:
//
func (action *Action) disconnectProxy(proxy Widgetter) {
	gclass := (*C.GtkActionClass)(coreglib.PeekParentClass(action))
	fnarg := gclass.disconnect_proxy

	var _arg0 *C.GtkAction // out
	var _arg1 *C.GtkWidget // out

	_arg0 = (*C.GtkAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))
	_arg1 = (*C.GtkWidget)(unsafe.Pointer(coreglib.InternObject(proxy).Native()))

	C._gotk4_gtk3_Action_virtual_disconnect_proxy(unsafe.Pointer(fnarg), _arg0, _arg1)
	runtime.KeepAlive(action)
	runtime.KeepAlive(proxy)
}

// ActionClass: instance of this type is always passed by reference.
type ActionClass struct {
	*actionClass
}

// actionClass is the struct that's finalized.
type actionClass struct {
	native *C.GtkActionClass
}
