// Code generated by girgen. DO NOT EDIT.

package gtk

import (
	"runtime"
)

// #include <stdlib.h>
// #include <gtk/gtk-a11y.h>
// #include <gtk/gtk.h>
// #include <gtk/gtkx.h>
import "C"

// RGBToHSV converts a color from RGB space to HSV.
//
// Input values must be in the [0.0, 1.0] range; output values will be in the
// same range.
//
// The function takes the following parameters:
//
//    - r: red.
//    - g: green.
//    - b: blue.
//
// The function returns the following values:
//
//    - h: return value for the hue component.
//    - s: return value for the saturation component.
//    - v: return value for the value component.
//
func RGBToHSV(r, g, b float64) (h, s, v float64) {
	var _arg1 C.gdouble // out
	var _arg2 C.gdouble // out
	var _arg3 C.gdouble // out
	var _arg4 C.gdouble // in
	var _arg5 C.gdouble // in
	var _arg6 C.gdouble // in

	_arg1 = C.gdouble(r)
	_arg2 = C.gdouble(g)
	_arg3 = C.gdouble(b)

	C.gtk_rgb_to_hsv(_arg1, _arg2, _arg3, &_arg4, &_arg5, &_arg6)
	runtime.KeepAlive(r)
	runtime.KeepAlive(g)
	runtime.KeepAlive(b)

	var _h float64 // out
	var _s float64 // out
	var _v float64 // out

	_h = float64(_arg4)
	_s = float64(_arg5)
	_v = float64(_arg6)

	return _h, _s, _v
}

// HSVToRGB converts a color from HSV space to RGB.
//
// Input values must be in the [0.0, 1.0] range; output values will be in the
// same range.
//
// The function takes the following parameters:
//
//    - h: hue.
//    - s: saturation.
//    - v: value.
//
// The function returns the following values:
//
//    - r: return value for the red component.
//    - g: return value for the green component.
//    - b: return value for the blue component.
//
func HSVToRGB(h, s, v float64) (r, g, b float64) {
	var _arg1 C.gdouble // out
	var _arg2 C.gdouble // out
	var _arg3 C.gdouble // out
	var _arg4 C.gdouble // in
	var _arg5 C.gdouble // in
	var _arg6 C.gdouble // in

	_arg1 = C.gdouble(h)
	_arg2 = C.gdouble(s)
	_arg3 = C.gdouble(v)

	C.gtk_hsv_to_rgb(_arg1, _arg2, _arg3, &_arg4, &_arg5, &_arg6)
	runtime.KeepAlive(h)
	runtime.KeepAlive(s)
	runtime.KeepAlive(v)

	var _r float64 // out
	var _g float64 // out
	var _b float64 // out

	_r = float64(_arg4)
	_g = float64(_arg5)
	_b = float64(_arg6)

	return _r, _g, _b
}
