// Code generated by girgen. DO NOT EDIT.

package gtk

import (
	"runtime"
	"unsafe"

	"github.com/diamondburned/gotk4/pkg/atk"
	"github.com/diamondburned/gotk4/pkg/core/gextras"
	coreglib "github.com/diamondburned/gotk4/pkg/core/glib"
	"github.com/diamondburned/gotk4/pkg/gdk/v3"
)

// #include <stdlib.h>
// #include <glib-object.h>
// #include <gtk/gtk-a11y.h>
// #include <gtk/gtk.h>
// #include <gtk/gtkx.h>
import "C"

// GType values.
var (
	GTypeInvisible = coreglib.Type(C.gtk_invisible_get_type())
)

func init() {
	coreglib.RegisterGValueMarshalers([]coreglib.TypeMarshaler{
		coreglib.TypeMarshaler{T: GTypeInvisible, F: marshalInvisible},
	})
}

// InvisibleOverrides contains methods that are overridable.
type InvisibleOverrides struct {
}

func defaultInvisibleOverrides(v *Invisible) InvisibleOverrides {
	return InvisibleOverrides{}
}

// Invisible widget is used internally in GTK+, and is probably not very useful
// for application developers.
//
// It is used for reliable pointer grabs and selection handling in the code for
// drag-and-drop.
type Invisible struct {
	_ [0]func() // equal guard
	Widget
}

var (
	_ Widgetter = (*Invisible)(nil)
)

func init() {
	coreglib.RegisterClassInfo[*Invisible, *InvisibleClass, InvisibleOverrides](
		GTypeInvisible,
		initInvisibleClass,
		wrapInvisible,
		defaultInvisibleOverrides,
	)
}

func initInvisibleClass(gclass unsafe.Pointer, overrides InvisibleOverrides, classInitFunc func(*InvisibleClass)) {
	if classInitFunc != nil {
		class := (*InvisibleClass)(gextras.NewStructNative(gclass))
		classInitFunc(class)
	}
}

func wrapInvisible(obj *coreglib.Object) *Invisible {
	return &Invisible{
		Widget: Widget{
			InitiallyUnowned: coreglib.InitiallyUnowned{
				Object: obj,
			},
			Object: obj,
			ImplementorIface: atk.ImplementorIface{
				Object: obj,
			},
			Buildable: Buildable{
				Object: obj,
			},
		},
	}
}

func marshalInvisible(p uintptr) (interface{}, error) {
	return wrapInvisible(coreglib.ValueFromNative(unsafe.Pointer(p)).Object()), nil
}

// NewInvisible creates a new Invisible.
//
// The function returns the following values:
//
//    - invisible: new Invisible.
//
func NewInvisible() *Invisible {
	var _cret *C.GtkWidget // in

	_cret = C.gtk_invisible_new()

	var _invisible *Invisible // out

	_invisible = wrapInvisible(coreglib.Take(unsafe.Pointer(_cret)))

	return _invisible
}

// NewInvisibleForScreen creates a new Invisible object for a specified screen.
//
// The function takes the following parameters:
//
//    - screen which identifies on which the new Invisible will be created.
//
// The function returns the following values:
//
//    - invisible: newly created Invisible object.
//
func NewInvisibleForScreen(screen *gdk.Screen) *Invisible {
	var _arg1 *C.GdkScreen // out
	var _cret *C.GtkWidget // in

	_arg1 = (*C.GdkScreen)(unsafe.Pointer(coreglib.InternObject(screen).Native()))

	_cret = C.gtk_invisible_new_for_screen(_arg1)
	runtime.KeepAlive(screen)

	var _invisible *Invisible // out

	_invisible = wrapInvisible(coreglib.Take(unsafe.Pointer(_cret)))

	return _invisible
}

// Screen returns the Screen object associated with invisible.
//
// The function returns the following values:
//
//    - screen: associated Screen.
//
func (invisible *Invisible) Screen() *gdk.Screen {
	var _arg0 *C.GtkInvisible // out
	var _cret *C.GdkScreen    // in

	_arg0 = (*C.GtkInvisible)(unsafe.Pointer(coreglib.InternObject(invisible).Native()))

	_cret = C.gtk_invisible_get_screen(_arg0)
	runtime.KeepAlive(invisible)

	var _screen *gdk.Screen // out

	{
		obj := coreglib.Take(unsafe.Pointer(_cret))
		_screen = &gdk.Screen{
			Object: obj,
		}
	}

	return _screen
}

// SetScreen sets the Screen where the Invisible object will be displayed.
//
// The function takes the following parameters:
//
//    - screen: Screen.
//
func (invisible *Invisible) SetScreen(screen *gdk.Screen) {
	var _arg0 *C.GtkInvisible // out
	var _arg1 *C.GdkScreen    // out

	_arg0 = (*C.GtkInvisible)(unsafe.Pointer(coreglib.InternObject(invisible).Native()))
	_arg1 = (*C.GdkScreen)(unsafe.Pointer(coreglib.InternObject(screen).Native()))

	C.gtk_invisible_set_screen(_arg0, _arg1)
	runtime.KeepAlive(invisible)
	runtime.KeepAlive(screen)
}

// InvisibleClass: instance of this type is always passed by reference.
type InvisibleClass struct {
	*invisibleClass
}

// invisibleClass is the struct that's finalized.
type invisibleClass struct {
	native *C.GtkInvisibleClass
}

func (i *InvisibleClass) ParentClass() *WidgetClass {
	valptr := &i.native.parent_class
	var _v *WidgetClass // out
	_v = (*WidgetClass)(gextras.NewStructNative(unsafe.Pointer(valptr)))
	return _v
}
