// Code generated by girgen. DO NOT EDIT.

package gtk

import (
	"runtime"
	"unsafe"

	"github.com/diamondburned/gotk4/pkg/core/gextras"
	coreglib "github.com/diamondburned/gotk4/pkg/core/glib"
)

// #include <stdlib.h>
// #include <glib-object.h>
// #include <gtk/gtk-a11y.h>
// #include <gtk/gtk.h>
// #include <gtk/gtkx.h>
// extern void _gotk4_gtk3_ToggleAction_ConnectToggled(gpointer, guintptr);
// extern void _gotk4_gtk3_ToggleActionClass_toggled(GtkToggleAction*);
// void _gotk4_gtk3_ToggleAction_virtual_toggled(void* fnptr, GtkToggleAction* arg0) {
//   ((void (*)(GtkToggleAction*))(fnptr))(arg0);
// };
import "C"

// GType values.
var (
	GTypeToggleAction = coreglib.Type(C.gtk_toggle_action_get_type())
)

func init() {
	coreglib.RegisterGValueMarshalers([]coreglib.TypeMarshaler{
		coreglib.TypeMarshaler{T: GTypeToggleAction, F: marshalToggleAction},
	})
}

// ToggleActionOverrides contains methods that are overridable.
type ToggleActionOverrides struct {
	// Toggled emits the “toggled” signal on the toggle action.
	//
	// Deprecated: since version 3.10.
	Toggled func()
}

func defaultToggleActionOverrides(v *ToggleAction) ToggleActionOverrides {
	return ToggleActionOverrides{
		Toggled: v.toggled,
	}
}

// ToggleAction corresponds roughly to a CheckMenuItem. It has an “active” state
// specifying whether the action has been checked or not.
type ToggleAction struct {
	_ [0]func() // equal guard
	Action
}

var (
	_ coreglib.Objector = (*ToggleAction)(nil)
)

func init() {
	coreglib.RegisterClassInfo[*ToggleAction, *ToggleActionClass, ToggleActionOverrides](
		GTypeToggleAction,
		initToggleActionClass,
		wrapToggleAction,
		defaultToggleActionOverrides,
	)
}

func initToggleActionClass(gclass unsafe.Pointer, overrides ToggleActionOverrides, classInitFunc func(*ToggleActionClass)) {
	pclass := (*C.GtkToggleActionClass)(unsafe.Pointer(C.g_type_check_class_cast((*C.GTypeClass)(gclass), C.GType(GTypeToggleAction))))

	if overrides.Toggled != nil {
		pclass.toggled = (*[0]byte)(C._gotk4_gtk3_ToggleActionClass_toggled)
	}

	if classInitFunc != nil {
		class := (*ToggleActionClass)(gextras.NewStructNative(gclass))
		classInitFunc(class)
	}
}

func wrapToggleAction(obj *coreglib.Object) *ToggleAction {
	return &ToggleAction{
		Action: Action{
			Object: obj,
			Buildable: Buildable{
				Object: obj,
			},
		},
	}
}

func marshalToggleAction(p uintptr) (interface{}, error) {
	return wrapToggleAction(coreglib.ValueFromNative(unsafe.Pointer(p)).Object()), nil
}

// ConnectToggled: should be connected if you wish to perform an action whenever
// the ToggleAction state is changed.
func (action *ToggleAction) ConnectToggled(f func()) coreglib.SignalHandle {
	return coreglib.ConnectGeneratedClosure(action, "toggled", false, unsafe.Pointer(C._gotk4_gtk3_ToggleAction_ConnectToggled), f)
}

// NewToggleAction creates a new ToggleAction object. To add the action to a
// ActionGroup and set the accelerator for the action, call
// gtk_action_group_add_action_with_accel().
//
// Deprecated: since version 3.10.
//
// The function takes the following parameters:
//
//    - name: unique name for the action.
//    - label (optional) displayed in menu items and on buttons, or NULL.
//    - tooltip (optional) for the action, or NULL.
//    - stockId (optional): stock icon to display in widgets representing the
//      action, or NULL.
//
// The function returns the following values:
//
//    - toggleAction: new ToggleAction.
//
func NewToggleAction(name, label, tooltip, stockId string) *ToggleAction {
	var _arg1 *C.gchar           // out
	var _arg2 *C.gchar           // out
	var _arg3 *C.gchar           // out
	var _arg4 *C.gchar           // out
	var _cret *C.GtkToggleAction // in

	_arg1 = (*C.gchar)(unsafe.Pointer(C.CString(name)))
	defer C.free(unsafe.Pointer(_arg1))
	if label != "" {
		_arg2 = (*C.gchar)(unsafe.Pointer(C.CString(label)))
		defer C.free(unsafe.Pointer(_arg2))
	}
	if tooltip != "" {
		_arg3 = (*C.gchar)(unsafe.Pointer(C.CString(tooltip)))
		defer C.free(unsafe.Pointer(_arg3))
	}
	if stockId != "" {
		_arg4 = (*C.gchar)(unsafe.Pointer(C.CString(stockId)))
		defer C.free(unsafe.Pointer(_arg4))
	}

	_cret = C.gtk_toggle_action_new(_arg1, _arg2, _arg3, _arg4)
	runtime.KeepAlive(name)
	runtime.KeepAlive(label)
	runtime.KeepAlive(tooltip)
	runtime.KeepAlive(stockId)

	var _toggleAction *ToggleAction // out

	_toggleAction = wrapToggleAction(coreglib.AssumeOwnership(unsafe.Pointer(_cret)))

	return _toggleAction
}

// Active returns the checked state of the toggle action.
//
// Deprecated: since version 3.10.
//
// The function returns the following values:
//
//    - ok: checked state of the toggle action.
//
func (action *ToggleAction) Active() bool {
	var _arg0 *C.GtkToggleAction // out
	var _cret C.gboolean         // in

	_arg0 = (*C.GtkToggleAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))

	_cret = C.gtk_toggle_action_get_active(_arg0)
	runtime.KeepAlive(action)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// DrawAsRadio returns whether the action should have proxies like a radio
// action.
//
// Deprecated: since version 3.10.
//
// The function returns the following values:
//
//    - ok: whether the action should have proxies like a radio action.
//
func (action *ToggleAction) DrawAsRadio() bool {
	var _arg0 *C.GtkToggleAction // out
	var _cret C.gboolean         // in

	_arg0 = (*C.GtkToggleAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))

	_cret = C.gtk_toggle_action_get_draw_as_radio(_arg0)
	runtime.KeepAlive(action)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// SetActive sets the checked state on the toggle action.
//
// Deprecated: since version 3.10.
//
// The function takes the following parameters:
//
//    - isActive: whether the action should be checked or not.
//
func (action *ToggleAction) SetActive(isActive bool) {
	var _arg0 *C.GtkToggleAction // out
	var _arg1 C.gboolean         // out

	_arg0 = (*C.GtkToggleAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))
	if isActive {
		_arg1 = C.TRUE
	}

	C.gtk_toggle_action_set_active(_arg0, _arg1)
	runtime.KeepAlive(action)
	runtime.KeepAlive(isActive)
}

// SetDrawAsRadio sets whether the action should have proxies like a radio
// action.
//
// Deprecated: since version 3.10.
//
// The function takes the following parameters:
//
//    - drawAsRadio: whether the action should have proxies like a radio action.
//
func (action *ToggleAction) SetDrawAsRadio(drawAsRadio bool) {
	var _arg0 *C.GtkToggleAction // out
	var _arg1 C.gboolean         // out

	_arg0 = (*C.GtkToggleAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))
	if drawAsRadio {
		_arg1 = C.TRUE
	}

	C.gtk_toggle_action_set_draw_as_radio(_arg0, _arg1)
	runtime.KeepAlive(action)
	runtime.KeepAlive(drawAsRadio)
}

// Toggled emits the “toggled” signal on the toggle action.
//
// Deprecated: since version 3.10.
func (action *ToggleAction) Toggled() {
	var _arg0 *C.GtkToggleAction // out

	_arg0 = (*C.GtkToggleAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))

	C.gtk_toggle_action_toggled(_arg0)
	runtime.KeepAlive(action)
}

// Toggled emits the “toggled” signal on the toggle action.
//
// Deprecated: since version 3.10.
func (action *ToggleAction) toggled() {
	gclass := (*C.GtkToggleActionClass)(coreglib.PeekParentClass(action))
	fnarg := gclass.toggled

	var _arg0 *C.GtkToggleAction // out

	_arg0 = (*C.GtkToggleAction)(unsafe.Pointer(coreglib.InternObject(action).Native()))

	C._gotk4_gtk3_ToggleAction_virtual_toggled(unsafe.Pointer(fnarg), _arg0)
	runtime.KeepAlive(action)
}

// ToggleActionClass: instance of this type is always passed by reference.
type ToggleActionClass struct {
	*toggleActionClass
}

// toggleActionClass is the struct that's finalized.
type toggleActionClass struct {
	native *C.GtkToggleActionClass
}

func (t *ToggleActionClass) ParentClass() *ActionClass {
	valptr := &t.native.parent_class
	var _v *ActionClass // out
	_v = (*ActionClass)(gextras.NewStructNative(unsafe.Pointer(valptr)))
	return _v
}
