// Code generated by girgen. DO NOT EDIT.

package gtk

import (
	"runtime"
	"unsafe"

	"github.com/diamondburned/gotk4/pkg/core/gextras"
	coreglib "github.com/diamondburned/gotk4/pkg/core/glib"
	"github.com/diamondburned/gotk4/pkg/gio/v2"
)

// #include <stdlib.h>
// #include <glib-object.h>
// #include <gtk/gtk.h>
import "C"

// GType values.
var (
	GTypeVideo = coreglib.Type(C.gtk_video_get_type())
)

func init() {
	coreglib.RegisterGValueMarshalers([]coreglib.TypeMarshaler{
		coreglib.TypeMarshaler{T: GTypeVideo, F: marshalVideo},
	})
}

// VideoOverrides contains methods that are overridable.
type VideoOverrides struct {
}

func defaultVideoOverrides(v *Video) VideoOverrides {
	return VideoOverrides{}
}

// Video: GtkVideo is a widget to show a GtkMediaStream with media controls.
//
// !An example GtkVideo (video.png)
//
// The controls are available separately as gtk.MediaControls. If you just want
// to display a video without controls, you can treat it like any other
// paintable and for example put it into a gtk.Picture.
//
// GtkVideo aims to cover use cases such as previews, embedded animations, etc.
// It supports autoplay, looping, and simple media controls. It does not have
// support for video overlays, multichannel audio, device selection, or input.
// If you are writing a full-fledged video player, you may want to use the
// gdk.Paintable API and a media framework such as Gstreamer directly.
type Video struct {
	_ [0]func() // equal guard
	Widget
}

var (
	_ Widgetter = (*Video)(nil)
)

func init() {
	coreglib.RegisterClassInfo[*Video, *VideoClass, VideoOverrides](
		GTypeVideo,
		initVideoClass,
		wrapVideo,
		defaultVideoOverrides,
	)
}

func initVideoClass(gclass unsafe.Pointer, overrides VideoOverrides, classInitFunc func(*VideoClass)) {
	if classInitFunc != nil {
		class := (*VideoClass)(gextras.NewStructNative(gclass))
		classInitFunc(class)
	}
}

func wrapVideo(obj *coreglib.Object) *Video {
	return &Video{
		Widget: Widget{
			InitiallyUnowned: coreglib.InitiallyUnowned{
				Object: obj,
			},
			Object: obj,
			Accessible: Accessible{
				Object: obj,
			},
			Buildable: Buildable{
				Object: obj,
			},
			ConstraintTarget: ConstraintTarget{
				Object: obj,
			},
		},
	}
}

func marshalVideo(p uintptr) (interface{}, error) {
	return wrapVideo(coreglib.ValueFromNative(unsafe.Pointer(p)).Object()), nil
}

// NewVideo creates a new empty GtkVideo.
//
// The function returns the following values:
//
//    - video: new GtkVideo.
//
func NewVideo() *Video {
	var _cret *C.GtkWidget // in

	_cret = C.gtk_video_new()

	var _video *Video // out

	_video = wrapVideo(coreglib.Take(unsafe.Pointer(_cret)))

	return _video
}

// NewVideoForFile creates a GtkVideo to play back the given file.
//
// The function takes the following parameters:
//
//    - file (optional): GFile.
//
// The function returns the following values:
//
//    - video: new GtkVideo.
//
func NewVideoForFile(file gio.Filer) *Video {
	var _arg1 *C.GFile     // out
	var _cret *C.GtkWidget // in

	if file != nil {
		_arg1 = (*C.GFile)(unsafe.Pointer(coreglib.InternObject(file).Native()))
	}

	_cret = C.gtk_video_new_for_file(_arg1)
	runtime.KeepAlive(file)

	var _video *Video // out

	_video = wrapVideo(coreglib.Take(unsafe.Pointer(_cret)))

	return _video
}

// NewVideoForFilename creates a GtkVideo to play back the given filename.
//
// This is a utility function that calls gtk.Video.NewForFile, See that function
// for details.
//
// The function takes the following parameters:
//
//    - filename (optional) to play back.
//
// The function returns the following values:
//
//    - video: new GtkVideo.
//
func NewVideoForFilename(filename string) *Video {
	var _arg1 *C.char      // out
	var _cret *C.GtkWidget // in

	if filename != "" {
		_arg1 = (*C.char)(unsafe.Pointer(C.CString(filename)))
		defer C.free(unsafe.Pointer(_arg1))
	}

	_cret = C.gtk_video_new_for_filename(_arg1)
	runtime.KeepAlive(filename)

	var _video *Video // out

	_video = wrapVideo(coreglib.Take(unsafe.Pointer(_cret)))

	return _video
}

// NewVideoForMediaStream creates a GtkVideo to play back the given stream.
//
// The function takes the following parameters:
//
//    - stream (optional): GtkMediaStream.
//
// The function returns the following values:
//
//    - video: new GtkVideo.
//
func NewVideoForMediaStream(stream MediaStreamer) *Video {
	var _arg1 *C.GtkMediaStream // out
	var _cret *C.GtkWidget      // in

	if stream != nil {
		_arg1 = (*C.GtkMediaStream)(unsafe.Pointer(coreglib.InternObject(stream).Native()))
	}

	_cret = C.gtk_video_new_for_media_stream(_arg1)
	runtime.KeepAlive(stream)

	var _video *Video // out

	_video = wrapVideo(coreglib.Take(unsafe.Pointer(_cret)))

	return _video
}

// NewVideoForResource creates a GtkVideo to play back the resource at the given
// resource_path.
//
// This is a utility function that calls gtk.Video.NewForFile.
//
// The function takes the following parameters:
//
//    - resourcePath (optional): resource path to play back.
//
// The function returns the following values:
//
//    - video: new GtkVideo.
//
func NewVideoForResource(resourcePath string) *Video {
	var _arg1 *C.char      // out
	var _cret *C.GtkWidget // in

	if resourcePath != "" {
		_arg1 = (*C.char)(unsafe.Pointer(C.CString(resourcePath)))
		defer C.free(unsafe.Pointer(_arg1))
	}

	_cret = C.gtk_video_new_for_resource(_arg1)
	runtime.KeepAlive(resourcePath)

	var _video *Video // out

	_video = wrapVideo(coreglib.Take(unsafe.Pointer(_cret)))

	return _video
}

// Autoplay returns TRUE if videos have been set to loop.
//
// The function returns the following values:
//
//    - ok: TRUE if streams should autoplay.
//
func (self *Video) Autoplay() bool {
	var _arg0 *C.GtkVideo // out
	var _cret C.gboolean  // in

	_arg0 = (*C.GtkVideo)(unsafe.Pointer(coreglib.InternObject(self).Native()))

	_cret = C.gtk_video_get_autoplay(_arg0)
	runtime.KeepAlive(self)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// File gets the file played by self or NULL if not playing back a file.
//
// The function returns the following values:
//
//    - file (optional) played by self.
//
func (self *Video) File() *gio.File {
	var _arg0 *C.GtkVideo // out
	var _cret *C.GFile    // in

	_arg0 = (*C.GtkVideo)(unsafe.Pointer(coreglib.InternObject(self).Native()))

	_cret = C.gtk_video_get_file(_arg0)
	runtime.KeepAlive(self)

	var _file *gio.File // out

	if _cret != nil {
		{
			obj := coreglib.Take(unsafe.Pointer(_cret))
			_file = &gio.File{
				Object: obj,
			}
		}
	}

	return _file
}

// Loop returns TRUE if videos have been set to loop.
//
// The function returns the following values:
//
//    - ok: TRUE if streams should loop.
//
func (self *Video) Loop() bool {
	var _arg0 *C.GtkVideo // out
	var _cret C.gboolean  // in

	_arg0 = (*C.GtkVideo)(unsafe.Pointer(coreglib.InternObject(self).Native()))

	_cret = C.gtk_video_get_loop(_arg0)
	runtime.KeepAlive(self)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// MediaStream gets the media stream managed by self or NULL if none.
//
// The function returns the following values:
//
//    - mediaStream (optional): media stream managed by self.
//
func (self *Video) MediaStream() MediaStreamer {
	var _arg0 *C.GtkVideo       // out
	var _cret *C.GtkMediaStream // in

	_arg0 = (*C.GtkVideo)(unsafe.Pointer(coreglib.InternObject(self).Native()))

	_cret = C.gtk_video_get_media_stream(_arg0)
	runtime.KeepAlive(self)

	var _mediaStream MediaStreamer // out

	if _cret != nil {
		{
			objptr := unsafe.Pointer(_cret)

			object := coreglib.Take(objptr)
			casted := object.WalkCast(func(obj coreglib.Objector) bool {
				_, ok := obj.(MediaStreamer)
				return ok
			})
			rv, ok := casted.(MediaStreamer)
			if !ok {
				panic("no marshaler for " + object.TypeFromInstance().String() + " matching gtk.MediaStreamer")
			}
			_mediaStream = rv
		}
	}

	return _mediaStream
}

// SetAutoplay sets whether self automatically starts playback when it becomes
// visible or when a new file gets loaded.
//
// The function takes the following parameters:
//
//    - autoplay: whether media streams should autoplay.
//
func (self *Video) SetAutoplay(autoplay bool) {
	var _arg0 *C.GtkVideo // out
	var _arg1 C.gboolean  // out

	_arg0 = (*C.GtkVideo)(unsafe.Pointer(coreglib.InternObject(self).Native()))
	if autoplay {
		_arg1 = C.TRUE
	}

	C.gtk_video_set_autoplay(_arg0, _arg1)
	runtime.KeepAlive(self)
	runtime.KeepAlive(autoplay)
}

// SetFile makes self play the given file.
//
// The function takes the following parameters:
//
//    - file (optional) to play.
//
func (self *Video) SetFile(file gio.Filer) {
	var _arg0 *C.GtkVideo // out
	var _arg1 *C.GFile    // out

	_arg0 = (*C.GtkVideo)(unsafe.Pointer(coreglib.InternObject(self).Native()))
	if file != nil {
		_arg1 = (*C.GFile)(unsafe.Pointer(coreglib.InternObject(file).Native()))
	}

	C.gtk_video_set_file(_arg0, _arg1)
	runtime.KeepAlive(self)
	runtime.KeepAlive(file)
}

// SetFilename makes self play the given filename.
//
// This is a utility function that calls gtk_video_set_file(),.
//
// The function takes the following parameters:
//
//    - filename (optional) to play.
//
func (self *Video) SetFilename(filename string) {
	var _arg0 *C.GtkVideo // out
	var _arg1 *C.char     // out

	_arg0 = (*C.GtkVideo)(unsafe.Pointer(coreglib.InternObject(self).Native()))
	if filename != "" {
		_arg1 = (*C.char)(unsafe.Pointer(C.CString(filename)))
		defer C.free(unsafe.Pointer(_arg1))
	}

	C.gtk_video_set_filename(_arg0, _arg1)
	runtime.KeepAlive(self)
	runtime.KeepAlive(filename)
}

// SetLoop sets whether new files loaded by self should be set to loop.
//
// The function takes the following parameters:
//
//    - loop: whether media streams should loop.
//
func (self *Video) SetLoop(loop bool) {
	var _arg0 *C.GtkVideo // out
	var _arg1 C.gboolean  // out

	_arg0 = (*C.GtkVideo)(unsafe.Pointer(coreglib.InternObject(self).Native()))
	if loop {
		_arg1 = C.TRUE
	}

	C.gtk_video_set_loop(_arg0, _arg1)
	runtime.KeepAlive(self)
	runtime.KeepAlive(loop)
}

// SetMediaStream sets the media stream to be played back.
//
// self will take full control of managing the media stream. If you want to
// manage a media stream yourself, consider using a gtk.Picture for display.
//
// If you want to display a file, consider using gtk.Video.SetFile() instead.
//
// The function takes the following parameters:
//
//    - stream (optional): media stream to play or NULL to unset.
//
func (self *Video) SetMediaStream(stream MediaStreamer) {
	var _arg0 *C.GtkVideo       // out
	var _arg1 *C.GtkMediaStream // out

	_arg0 = (*C.GtkVideo)(unsafe.Pointer(coreglib.InternObject(self).Native()))
	if stream != nil {
		_arg1 = (*C.GtkMediaStream)(unsafe.Pointer(coreglib.InternObject(stream).Native()))
	}

	C.gtk_video_set_media_stream(_arg0, _arg1)
	runtime.KeepAlive(self)
	runtime.KeepAlive(stream)
}

// SetResource makes self play the resource at the given resource_path.
//
// This is a utility function that calls gtk.Video.SetFile().
//
// The function takes the following parameters:
//
//    - resourcePath (optional): resource to set.
//
func (self *Video) SetResource(resourcePath string) {
	var _arg0 *C.GtkVideo // out
	var _arg1 *C.char     // out

	_arg0 = (*C.GtkVideo)(unsafe.Pointer(coreglib.InternObject(self).Native()))
	if resourcePath != "" {
		_arg1 = (*C.char)(unsafe.Pointer(C.CString(resourcePath)))
		defer C.free(unsafe.Pointer(_arg1))
	}

	C.gtk_video_set_resource(_arg0, _arg1)
	runtime.KeepAlive(self)
	runtime.KeepAlive(resourcePath)
}

// VideoClass: instance of this type is always passed by reference.
type VideoClass struct {
	*videoClass
}

// videoClass is the struct that's finalized.
type videoClass struct {
	native *C.GtkVideoClass
}

func (v *VideoClass) ParentClass() *WidgetClass {
	valptr := &v.native.parent_class
	var _v *WidgetClass // out
	_v = (*WidgetClass)(gextras.NewStructNative(unsafe.Pointer(valptr)))
	return _v
}
