// Code generated by girgen. DO NOT EDIT.

package pango

import (
	"fmt"
	"runtime"
	"strings"
	"unsafe"

	"github.com/diamondburned/gotk4/pkg/core/gbox"
	"github.com/diamondburned/gotk4/pkg/core/gerror"
	"github.com/diamondburned/gotk4/pkg/core/gextras"
	coreglib "github.com/diamondburned/gotk4/pkg/core/glib"
)

// #include <stdlib.h>
// #include <glib-object.h>
// #include <pango/pango.h>
// extern gboolean _gotk4_pango1_AttrFilterFunc(PangoAttribute*, gpointer);
import "C"

// GType values.
var (
	GTypeAttrType     = coreglib.Type(C.pango_attr_type_get_type())
	GTypeUnderline    = coreglib.Type(C.pango_underline_get_type())
	GTypeShowFlags    = coreglib.Type(C.pango_show_flags_get_type())
	GTypeAttrIterator = coreglib.Type(C.pango_attr_iterator_get_type())
	GTypeAttrList     = coreglib.Type(C.pango_attr_list_get_type())
	GTypeAttribute    = coreglib.Type(C.pango_attribute_get_type())
	GTypeColor        = coreglib.Type(C.pango_color_get_type())
)

func init() {
	coreglib.RegisterGValueMarshalers([]coreglib.TypeMarshaler{
		coreglib.TypeMarshaler{T: GTypeAttrType, F: marshalAttrType},
		coreglib.TypeMarshaler{T: GTypeUnderline, F: marshalUnderline},
		coreglib.TypeMarshaler{T: GTypeShowFlags, F: marshalShowFlags},
		coreglib.TypeMarshaler{T: GTypeAttrIterator, F: marshalAttrIterator},
		coreglib.TypeMarshaler{T: GTypeAttrList, F: marshalAttrList},
		coreglib.TypeMarshaler{T: GTypeAttribute, F: marshalAttribute},
		coreglib.TypeMarshaler{T: GTypeColor, F: marshalColor},
	})
}

// AttrType: PangoAttrType distinguishes between different types of attributes.
//
// Along with the predefined values, it is possible to allocate additional
// values for custom attributes using attr_type_register. The predefined values
// are given below. The type of structure used to store the attribute is listed
// in parentheses after the description.
type AttrType C.gint

const (
	// AttrTypeInvalid does not happen.
	AttrTypeInvalid AttrType = iota
	// AttrTypeLanguage: language (pango.AttrLanguage).
	AttrTypeLanguage
	// AttrTypeFamily: font family name list (pango.AttrString).
	AttrTypeFamily
	// AttrTypeStyle: font slant style (pango.AttrInt).
	AttrTypeStyle
	// AttrTypeWeight: font weight (pango.AttrInt).
	AttrTypeWeight
	// AttrTypeVariant: font variant (normal or small caps) (pango.AttrInt).
	AttrTypeVariant
	// AttrTypeStretch: font stretch (pango.AttrInt).
	AttrTypeStretch
	// AttrTypeSize: font size in points scaled by PANGO_SCALE (pango.AttrInt).
	AttrTypeSize
	// AttrTypeFontDesc: font description (pango.AttrFontDesc).
	AttrTypeFontDesc
	// AttrTypeForeground: foreground color (pango.AttrColor).
	AttrTypeForeground
	// AttrTypeBackground: background color (pango.AttrColor).
	AttrTypeBackground
	// AttrTypeUnderline: whether the text has an underline (pango.AttrInt).
	AttrTypeUnderline
	// AttrTypeStrikethrough: whether the text is struck-through
	// (pango.AttrInt).
	AttrTypeStrikethrough
	// AttrTypeRise: baseline displacement (pango.AttrInt).
	AttrTypeRise
	// AttrTypeShape: shape (pango.AttrShape).
	AttrTypeShape
	// AttrTypeScale: font size scale factor (pango.AttrFloat).
	AttrTypeScale
	// AttrTypeFallback: whether fallback is enabled (pango.AttrInt).
	AttrTypeFallback
	// AttrTypeLetterSpacing: letter spacing (pangoattrint).
	AttrTypeLetterSpacing
	// AttrTypeUnderlineColor: underline color (pango.AttrColor).
	AttrTypeUnderlineColor
	// AttrTypeStrikethroughColor: strikethrough color (pango.AttrColor).
	AttrTypeStrikethroughColor
	// AttrTypeAbsoluteSize: font size in pixels scaled by PANGO_SCALE
	// (pango.AttrInt).
	AttrTypeAbsoluteSize
	// AttrTypeGravity: base text gravity (pango.AttrInt).
	AttrTypeGravity
	// AttrTypeGravityHint: gravity hint (pango.AttrInt).
	AttrTypeGravityHint
	// AttrTypeFontFeatures: openType font features (pango.AttrString). Since
	// 1.38.
	AttrTypeFontFeatures
	// AttrTypeForegroundAlpha: foreground alpha (pango.AttrInt). Since 1.38.
	AttrTypeForegroundAlpha
	// AttrTypeBackgroundAlpha: background alpha (pango.AttrInt). Since 1.38.
	AttrTypeBackgroundAlpha
	// AttrTypeAllowBreaks: whether breaks are allowed (pango.AttrInt). Since
	// 1.44.
	AttrTypeAllowBreaks
	// AttrTypeShow: how to render invisible characters (pango.AttrInt). Since
	// 1.44.
	AttrTypeShow
	// AttrTypeInsertHyphens: whether to insert hyphens at intra-word line
	// breaks (pango.AttrInt). Since 1.44.
	AttrTypeInsertHyphens
	// AttrTypeOverline: whether the text has an overline (pango.AttrInt). Since
	// 1.46.
	AttrTypeOverline
	// AttrTypeOverlineColor: overline color (pango.AttrColor). Since 1.46.
	AttrTypeOverlineColor
)

func marshalAttrType(p uintptr) (interface{}, error) {
	return AttrType(coreglib.ValueFromNative(unsafe.Pointer(p)).Enum()), nil
}

// String returns the name in string for AttrType.
func (a AttrType) String() string {
	switch a {
	case AttrTypeInvalid:
		return "Invalid"
	case AttrTypeLanguage:
		return "Language"
	case AttrTypeFamily:
		return "Family"
	case AttrTypeStyle:
		return "Style"
	case AttrTypeWeight:
		return "Weight"
	case AttrTypeVariant:
		return "Variant"
	case AttrTypeStretch:
		return "Stretch"
	case AttrTypeSize:
		return "Size"
	case AttrTypeFontDesc:
		return "FontDesc"
	case AttrTypeForeground:
		return "Foreground"
	case AttrTypeBackground:
		return "Background"
	case AttrTypeUnderline:
		return "Underline"
	case AttrTypeStrikethrough:
		return "Strikethrough"
	case AttrTypeRise:
		return "Rise"
	case AttrTypeShape:
		return "Shape"
	case AttrTypeScale:
		return "Scale"
	case AttrTypeFallback:
		return "Fallback"
	case AttrTypeLetterSpacing:
		return "LetterSpacing"
	case AttrTypeUnderlineColor:
		return "UnderlineColor"
	case AttrTypeStrikethroughColor:
		return "StrikethroughColor"
	case AttrTypeAbsoluteSize:
		return "AbsoluteSize"
	case AttrTypeGravity:
		return "Gravity"
	case AttrTypeGravityHint:
		return "GravityHint"
	case AttrTypeFontFeatures:
		return "FontFeatures"
	case AttrTypeForegroundAlpha:
		return "ForegroundAlpha"
	case AttrTypeBackgroundAlpha:
		return "BackgroundAlpha"
	case AttrTypeAllowBreaks:
		return "AllowBreaks"
	case AttrTypeShow:
		return "Show"
	case AttrTypeInsertHyphens:
		return "InsertHyphens"
	case AttrTypeOverline:
		return "Overline"
	case AttrTypeOverlineColor:
		return "OverlineColor"
	default:
		return fmt.Sprintf("AttrType(%d)", a)
	}
}

// AttrTypeRegister: allocate a new attribute type ID.
//
// The attribute type name can be accessed later by using
// pango.AttrType.GetName.
//
// The function takes the following parameters:
//
//    - name: identifier for the type.
//
// The function returns the following values:
//
//    - attrType: new type ID.
//
func AttrTypeRegister(name string) AttrType {
	var _arg1 *C.gchar        // out
	var _cret C.PangoAttrType // in

	_arg1 = (*C.gchar)(unsafe.Pointer(C.CString(name)))
	defer C.free(unsafe.Pointer(_arg1))

	_cret = C.pango_attr_type_register(_arg1)
	runtime.KeepAlive(name)

	var _attrType AttrType // out

	_attrType = AttrType(_cret)

	return _attrType
}

// Underline: PangoUnderline enumeration is used to specify whether text should
// be underlined, and if so, the type of underlining.
type Underline C.gint

const (
	// UnderlineNone: no underline should be drawn.
	UnderlineNone Underline = iota
	// UnderlineSingle: single underline should be drawn.
	UnderlineSingle
	// UnderlineDouble: double underline should be drawn.
	UnderlineDouble
	// UnderlineLow: single underline should be drawn at a position beneath the
	// ink extents of the text being underlined. This should be used only for
	// underlining single characters, such as for keyboard accelerators.
	// PANGO_UNDERLINE_SINGLE should be used for extended portions of text.
	UnderlineLow
	// UnderlineError: wavy underline should be drawn below. This underline is
	// typically used to indicate an error such as a possible mispelling; in
	// some cases a contrasting color may automatically be used. This type of
	// underlining is available since Pango 1.4.
	UnderlineError
	// UnderlineSingleLine: like PANGO_UNDERLINE_SINGLE, but drawn continuously
	// across multiple runs. This type of underlining is available since Pango
	// 1.46.
	UnderlineSingleLine
	// UnderlineDoubleLine: like PANGO_UNDERLINE_DOUBLE, but drawn continuously
	// across multiple runs. This type of underlining is available since Pango
	// 1.46.
	UnderlineDoubleLine
	// UnderlineErrorLine: like PANGO_UNDERLINE_ERROR, but drawn continuously
	// across multiple runs. This type of underlining is available since Pango
	// 1.46.
	UnderlineErrorLine
)

func marshalUnderline(p uintptr) (interface{}, error) {
	return Underline(coreglib.ValueFromNative(unsafe.Pointer(p)).Enum()), nil
}

// String returns the name in string for Underline.
func (u Underline) String() string {
	switch u {
	case UnderlineNone:
		return "None"
	case UnderlineSingle:
		return "Single"
	case UnderlineDouble:
		return "Double"
	case UnderlineLow:
		return "Low"
	case UnderlineError:
		return "Error"
	case UnderlineSingleLine:
		return "SingleLine"
	case UnderlineDoubleLine:
		return "DoubleLine"
	case UnderlineErrorLine:
		return "ErrorLine"
	default:
		return fmt.Sprintf("Underline(%d)", u)
	}
}

// ShowFlags: these flags affect how Pango treats characters that are normally
// not visible in the output.
type ShowFlags C.guint

const (
	// ShowNone: no special treatment for invisible characters.
	ShowNone ShowFlags = 0b0
	// ShowSpaces: render spaces, tabs and newlines visibly.
	ShowSpaces ShowFlags = 0b1
	// ShowLineBreaks: render line breaks visibly.
	ShowLineBreaks ShowFlags = 0b10
	// ShowIgnorables: render default-ignorable Unicode characters visibly.
	ShowIgnorables ShowFlags = 0b100
)

func marshalShowFlags(p uintptr) (interface{}, error) {
	return ShowFlags(coreglib.ValueFromNative(unsafe.Pointer(p)).Flags()), nil
}

// String returns the names in string for ShowFlags.
func (s ShowFlags) String() string {
	if s == 0 {
		return "ShowFlags(0)"
	}

	var builder strings.Builder
	builder.Grow(49)

	for s != 0 {
		next := s & (s - 1)
		bit := s - next

		switch bit {
		case ShowNone:
			builder.WriteString("None|")
		case ShowSpaces:
			builder.WriteString("Spaces|")
		case ShowLineBreaks:
			builder.WriteString("LineBreaks|")
		case ShowIgnorables:
			builder.WriteString("Ignorables|")
		default:
			builder.WriteString(fmt.Sprintf("ShowFlags(0b%b)|", bit))
		}

		s = next
	}

	return strings.TrimSuffix(builder.String(), "|")
}

// Has returns true if s contains other.
func (s ShowFlags) Has(other ShowFlags) bool {
	return (s & other) == other
}

// AttrDataCopyFunc: type of a function that can duplicate user data for an
// attribute.
type AttrDataCopyFunc func() (gpointer unsafe.Pointer)

// AttrFilterFunc: type of a function filtering a list of attributes.
type AttrFilterFunc func(attribute *Attribute) (ok bool)

// NewAttrBackground: create a new background color attribute.
//
// The function takes the following parameters:
//
//    - red value (ranging from 0 to 65535).
//    - green value.
//    - blue value.
//
// The function returns the following values:
//
//    - attribute: newly allocated PangoAttribute, which should be freed with
//      pango.Attribute.Destroy().
//
func NewAttrBackground(red, green, blue uint16) *Attribute {
	var _arg1 C.guint16         // out
	var _arg2 C.guint16         // out
	var _arg3 C.guint16         // out
	var _cret *C.PangoAttribute // in

	_arg1 = C.guint16(red)
	_arg2 = C.guint16(green)
	_arg3 = C.guint16(blue)

	_cret = C.pango_attr_background_new(_arg1, _arg2, _arg3)
	runtime.KeepAlive(red)
	runtime.KeepAlive(green)
	runtime.KeepAlive(blue)

	var _attribute *Attribute // out

	_attribute = (*Attribute)(gextras.NewStructNative(unsafe.Pointer(_cret)))
	runtime.SetFinalizer(
		gextras.StructIntern(unsafe.Pointer(_attribute)),
		func(intern *struct{ C unsafe.Pointer }) {
			C.pango_attribute_destroy((*C.PangoAttribute)(intern.C))
		},
	)

	return _attribute
}

// NewAttrFamily: create a new font family attribute.
//
// The function takes the following parameters:
//
//    - family or comma separated list of families.
//
// The function returns the following values:
//
//    - attribute: newly allocated PangoAttribute which should be freed with
//      pango.Attribute.Destroy().
//
func NewAttrFamily(family string) *Attribute {
	var _arg1 *C.char           // out
	var _cret *C.PangoAttribute // in

	_arg1 = (*C.char)(unsafe.Pointer(C.CString(family)))
	defer C.free(unsafe.Pointer(_arg1))

	_cret = C.pango_attr_family_new(_arg1)
	runtime.KeepAlive(family)

	var _attribute *Attribute // out

	_attribute = (*Attribute)(gextras.NewStructNative(unsafe.Pointer(_cret)))
	runtime.SetFinalizer(
		gextras.StructIntern(unsafe.Pointer(_attribute)),
		func(intern *struct{ C unsafe.Pointer }) {
			C.pango_attribute_destroy((*C.PangoAttribute)(intern.C))
		},
	)

	return _attribute
}

// NewAttrForeground: create a new foreground color attribute.
//
// The function takes the following parameters:
//
//    - red value (ranging from 0 to 65535).
//    - green value.
//    - blue value.
//
// The function returns the following values:
//
//    - attribute: newly allocated PangoAttribute, which should be freed with
//      pango.Attribute.Destroy().
//
func NewAttrForeground(red, green, blue uint16) *Attribute {
	var _arg1 C.guint16         // out
	var _arg2 C.guint16         // out
	var _arg3 C.guint16         // out
	var _cret *C.PangoAttribute // in

	_arg1 = C.guint16(red)
	_arg2 = C.guint16(green)
	_arg3 = C.guint16(blue)

	_cret = C.pango_attr_foreground_new(_arg1, _arg2, _arg3)
	runtime.KeepAlive(red)
	runtime.KeepAlive(green)
	runtime.KeepAlive(blue)

	var _attribute *Attribute // out

	_attribute = (*Attribute)(gextras.NewStructNative(unsafe.Pointer(_cret)))
	runtime.SetFinalizer(
		gextras.StructIntern(unsafe.Pointer(_attribute)),
		func(intern *struct{ C unsafe.Pointer }) {
			C.pango_attribute_destroy((*C.PangoAttribute)(intern.C))
		},
	)

	return _attribute
}

// NewAttrRise: create a new baseline displacement attribute.
//
// The function takes the following parameters:
//
//    - rise: amount that the text should be displaced vertically, in Pango
//      units. Positive values displace the text upwards.
//
// The function returns the following values:
//
//    - attribute: newly allocated PangoAttribute, which should be freed with
//      pango.Attribute.Destroy().
//
func NewAttrRise(rise int) *Attribute {
	var _arg1 C.int             // out
	var _cret *C.PangoAttribute // in

	_arg1 = C.int(rise)

	_cret = C.pango_attr_rise_new(_arg1)
	runtime.KeepAlive(rise)

	var _attribute *Attribute // out

	_attribute = (*Attribute)(gextras.NewStructNative(unsafe.Pointer(_cret)))
	runtime.SetFinalizer(
		gextras.StructIntern(unsafe.Pointer(_attribute)),
		func(intern *struct{ C unsafe.Pointer }) {
			C.pango_attribute_destroy((*C.PangoAttribute)(intern.C))
		},
	)

	return _attribute
}

// NewAttrScale: create a new font size scale attribute.
//
// The base font for the affected text will have its size multiplied by
// scale_factor.
//
// The function takes the following parameters:
//
//    - scaleFactor: factor to scale the font.
//
// The function returns the following values:
//
//    - attribute: newly allocated PangoAttribute, which should be freed with
//      pango.Attribute.Destroy().
//
func NewAttrScale(scaleFactor float64) *Attribute {
	var _arg1 C.double          // out
	var _cret *C.PangoAttribute // in

	_arg1 = C.double(scaleFactor)

	_cret = C.pango_attr_scale_new(_arg1)
	runtime.KeepAlive(scaleFactor)

	var _attribute *Attribute // out

	_attribute = (*Attribute)(gextras.NewStructNative(unsafe.Pointer(_cret)))
	runtime.SetFinalizer(
		gextras.StructIntern(unsafe.Pointer(_attribute)),
		func(intern *struct{ C unsafe.Pointer }) {
			C.pango_attribute_destroy((*C.PangoAttribute)(intern.C))
		},
	)

	return _attribute
}

// NewAttrStretch: create a new font stretch attribute.
//
// The function takes the following parameters:
//
//    - stretch: stretch.
//
// The function returns the following values:
//
//    - attribute: newly allocated PangoAttribute, which should be freed with
//      pango.Attribute.Destroy().
//
func NewAttrStretch(stretch Stretch) *Attribute {
	var _arg1 C.PangoStretch    // out
	var _cret *C.PangoAttribute // in

	_arg1 = C.PangoStretch(stretch)

	_cret = C.pango_attr_stretch_new(_arg1)
	runtime.KeepAlive(stretch)

	var _attribute *Attribute // out

	_attribute = (*Attribute)(gextras.NewStructNative(unsafe.Pointer(_cret)))
	runtime.SetFinalizer(
		gextras.StructIntern(unsafe.Pointer(_attribute)),
		func(intern *struct{ C unsafe.Pointer }) {
			C.pango_attribute_destroy((*C.PangoAttribute)(intern.C))
		},
	)

	return _attribute
}

// NewAttrStrikethrough: create a new strike-through attribute.
//
// The function takes the following parameters:
//
//    - strikethrough: TRUE if the text should be struck-through.
//
// The function returns the following values:
//
//    - attribute: newly allocated PangoAttribute, which should be freed with
//      pango.Attribute.Destroy().
//
func NewAttrStrikethrough(strikethrough bool) *Attribute {
	var _arg1 C.gboolean        // out
	var _cret *C.PangoAttribute // in

	if strikethrough {
		_arg1 = C.TRUE
	}

	_cret = C.pango_attr_strikethrough_new(_arg1)
	runtime.KeepAlive(strikethrough)

	var _attribute *Attribute // out

	_attribute = (*Attribute)(gextras.NewStructNative(unsafe.Pointer(_cret)))
	runtime.SetFinalizer(
		gextras.StructIntern(unsafe.Pointer(_attribute)),
		func(intern *struct{ C unsafe.Pointer }) {
			C.pango_attribute_destroy((*C.PangoAttribute)(intern.C))
		},
	)

	return _attribute
}

// NewAttrStyle: create a new font slant style attribute.
//
// The function takes the following parameters:
//
//    - style: slant style.
//
// The function returns the following values:
//
//    - attribute: newly allocated PangoAttribute, which should be freed with
//      pango.Attribute.Destroy().
//
func NewAttrStyle(style Style) *Attribute {
	var _arg1 C.PangoStyle      // out
	var _cret *C.PangoAttribute // in

	_arg1 = C.PangoStyle(style)

	_cret = C.pango_attr_style_new(_arg1)
	runtime.KeepAlive(style)

	var _attribute *Attribute // out

	_attribute = (*Attribute)(gextras.NewStructNative(unsafe.Pointer(_cret)))
	runtime.SetFinalizer(
		gextras.StructIntern(unsafe.Pointer(_attribute)),
		func(intern *struct{ C unsafe.Pointer }) {
			C.pango_attribute_destroy((*C.PangoAttribute)(intern.C))
		},
	)

	return _attribute
}

// NewAttrUnderline: create a new underline-style attribute.
//
// The function takes the following parameters:
//
//    - underline style.
//
// The function returns the following values:
//
//    - attribute: newly allocated PangoAttribute, which should be freed with
//      pango.Attribute.Destroy().
//
func NewAttrUnderline(underline Underline) *Attribute {
	var _arg1 C.PangoUnderline  // out
	var _cret *C.PangoAttribute // in

	_arg1 = C.PangoUnderline(underline)

	_cret = C.pango_attr_underline_new(_arg1)
	runtime.KeepAlive(underline)

	var _attribute *Attribute // out

	_attribute = (*Attribute)(gextras.NewStructNative(unsafe.Pointer(_cret)))
	runtime.SetFinalizer(
		gextras.StructIntern(unsafe.Pointer(_attribute)),
		func(intern *struct{ C unsafe.Pointer }) {
			C.pango_attribute_destroy((*C.PangoAttribute)(intern.C))
		},
	)

	return _attribute
}

// NewAttrVariant: create a new font variant attribute (normal or small caps).
//
// The function takes the following parameters:
//
//    - variant: variant.
//
// The function returns the following values:
//
//    - attribute: newly allocated PangoAttribute, which should be freed with
//      pango.Attribute.Destroy().
//
func NewAttrVariant(variant Variant) *Attribute {
	var _arg1 C.PangoVariant    // out
	var _cret *C.PangoAttribute // in

	_arg1 = C.PangoVariant(variant)

	_cret = C.pango_attr_variant_new(_arg1)
	runtime.KeepAlive(variant)

	var _attribute *Attribute // out

	_attribute = (*Attribute)(gextras.NewStructNative(unsafe.Pointer(_cret)))
	runtime.SetFinalizer(
		gextras.StructIntern(unsafe.Pointer(_attribute)),
		func(intern *struct{ C unsafe.Pointer }) {
			C.pango_attribute_destroy((*C.PangoAttribute)(intern.C))
		},
	)

	return _attribute
}

// NewAttrWeight: create a new font weight attribute.
//
// The function takes the following parameters:
//
//    - weight: weight.
//
// The function returns the following values:
//
//    - attribute: newly allocated PangoAttribute, which should be freed with
//      pango.Attribute.Destroy().
//
func NewAttrWeight(weight Weight) *Attribute {
	var _arg1 C.PangoWeight     // out
	var _cret *C.PangoAttribute // in

	_arg1 = C.PangoWeight(weight)

	_cret = C.pango_attr_weight_new(_arg1)
	runtime.KeepAlive(weight)

	var _attribute *Attribute // out

	_attribute = (*Attribute)(gextras.NewStructNative(unsafe.Pointer(_cret)))
	runtime.SetFinalizer(
		gextras.StructIntern(unsafe.Pointer(_attribute)),
		func(intern *struct{ C unsafe.Pointer }) {
			C.pango_attribute_destroy((*C.PangoAttribute)(intern.C))
		},
	)

	return _attribute
}

// ParseMarkup parses marked-up text to create a plain-text string and an
// attribute list.
//
// See the Pango Markup (pango_markup.html) docs for details about the supported
// markup.
//
// If accel_marker is nonzero, the given character will mark the character
// following it as an accelerator. For example, accel_marker might be an
// ampersand or underscore. All characters marked as an accelerator will receive
// a PANGO_UNDERLINE_LOW attribute, and the first character so marked will be
// returned in accel_char. Two accel_marker characters following each other
// produce a single literal accel_marker character.
//
// To parse a stream of pango markup incrementally, use markup_parser_new.
//
// If any error happens, none of the output arguments are touched except for
// error.
//
// The function takes the following parameters:
//
//    - markupText: markup to parse (see the Pango Markup docs).
//    - length of markup_text, or -1 if nul-terminated.
//    - accelMarker: character that precedes an accelerator, or 0 for none.
//
// The function returns the following values:
//
//    - attrList (optional) address of return location for a PangoAttrList, or
//      NULL.
//    - text (optional) address of return location for text with tags stripped,
//      or NULL.
//    - accelChar (optional) address of return location for accelerator char, or
//      NULL.
//
func ParseMarkup(markupText string, length int, accelMarker uint32) (*AttrList, string, uint32, error) {
	var _arg1 *C.char          // out
	var _arg2 C.int            // out
	var _arg3 C.gunichar       // out
	var _arg4 *C.PangoAttrList // in
	var _arg5 *C.char          // in
	var _arg6 C.gunichar       // in
	var _cerr *C.GError        // in

	_arg1 = (*C.char)(unsafe.Pointer(C.CString(markupText)))
	defer C.free(unsafe.Pointer(_arg1))
	_arg2 = C.int(length)
	_arg3 = C.gunichar(accelMarker)

	C.pango_parse_markup(_arg1, _arg2, _arg3, &_arg4, &_arg5, &_arg6, &_cerr)
	runtime.KeepAlive(markupText)
	runtime.KeepAlive(length)
	runtime.KeepAlive(accelMarker)

	var _attrList *AttrList // out
	var _text string        // out
	var _accelChar uint32   // out
	var _goerr error        // out

	if _arg4 != nil {
		_attrList = (*AttrList)(gextras.NewStructNative(unsafe.Pointer(_arg4)))
		runtime.SetFinalizer(
			gextras.StructIntern(unsafe.Pointer(_attrList)),
			func(intern *struct{ C unsafe.Pointer }) {
				C.pango_attr_list_unref((*C.PangoAttrList)(intern.C))
			},
		)
	}
	if _arg5 != nil {
		_text = C.GoString((*C.gchar)(unsafe.Pointer(_arg5)))
		defer C.free(unsafe.Pointer(_arg5))
	}
	_accelChar = uint32(_arg6)
	if _cerr != nil {
		_goerr = gerror.Take(unsafe.Pointer(_cerr))
	}

	return _attrList, _text, _accelChar, _goerr
}

// AttrClass: PangoAttrClass structure stores the type and operations for a
// particular type of attribute.
//
// The functions in this structure should not be called directly. Instead, one
// should use the wrapper functions provided for PangoAttribute.
//
// An instance of this type is always passed by reference.
type AttrClass struct {
	*attrClass
}

// attrClass is the struct that's finalized.
type attrClass struct {
	native *C.PangoAttrClass
}

// Type: type ID for this attribute.
func (a *AttrClass) Type() AttrType {
	valptr := &a.native._type
	var _v AttrType // out
	_v = AttrType(*valptr)
	return _v
}

// AttrColor: PangoAttrColor structure is used to represent attributes that are
// colors.
//
// An instance of this type is always passed by reference.
type AttrColor struct {
	*attrColor
}

// attrColor is the struct that's finalized.
type attrColor struct {
	native *C.PangoAttrColor
}

// Attr: common portion of the attribute.
func (a *AttrColor) Attr() *Attribute {
	valptr := &a.native.attr
	var _v *Attribute // out
	_v = (*Attribute)(gextras.NewStructNative(unsafe.Pointer(valptr)))
	return _v
}

// Color: PangoColor which is the value of the attribute.
func (a *AttrColor) Color() *Color {
	valptr := &a.native.color
	var _v *Color // out
	_v = (*Color)(gextras.NewStructNative(unsafe.Pointer(valptr)))
	return _v
}

// AttrFloat: PangoAttrFloat structure is used to represent attributes with a
// float or double value.
//
// An instance of this type is always passed by reference.
type AttrFloat struct {
	*attrFloat
}

// attrFloat is the struct that's finalized.
type attrFloat struct {
	native *C.PangoAttrFloat
}

// Attr: common portion of the attribute.
func (a *AttrFloat) Attr() *Attribute {
	valptr := &a.native.attr
	var _v *Attribute // out
	_v = (*Attribute)(gextras.NewStructNative(unsafe.Pointer(valptr)))
	return _v
}

// Value: value of the attribute.
func (a *AttrFloat) Value() float64 {
	valptr := &a.native.value
	var _v float64 // out
	_v = float64(*valptr)
	return _v
}

// Value: value of the attribute.
func (a *AttrFloat) SetValue(value float64) {
	valptr := &a.native.value
	*valptr = C.double(value)
}

// AttrFontDesc: PangoAttrFontDesc structure is used to store an attribute that
// sets all aspects of the font description at once.
//
// An instance of this type is always passed by reference.
type AttrFontDesc struct {
	*attrFontDesc
}

// attrFontDesc is the struct that's finalized.
type attrFontDesc struct {
	native *C.PangoAttrFontDesc
}

// Attr: common portion of the attribute.
func (a *AttrFontDesc) Attr() *Attribute {
	valptr := &a.native.attr
	var _v *Attribute // out
	_v = (*Attribute)(gextras.NewStructNative(unsafe.Pointer(valptr)))
	return _v
}

// Desc: font description which is the value of this attribute.
func (a *AttrFontDesc) Desc() *FontDescription {
	valptr := &a.native.desc
	var _v *FontDescription // out
	_v = (*FontDescription)(gextras.NewStructNative(unsafe.Pointer(*valptr)))
	return _v
}

// NewAttrFontDesc: create a new font description attribute.
//
// This attribute allows setting family, style, weight, variant, stretch, and
// size simultaneously.
//
// The function takes the following parameters:
//
//    - desc: font description.
//
// The function returns the following values:
//
//    - attribute: newly allocated PangoAttribute, which should be freed with
//      pango.Attribute.Destroy().
//
func NewAttrFontDesc(desc *FontDescription) *Attribute {
	var _arg1 *C.PangoFontDescription // out
	var _cret *C.PangoAttribute       // in

	_arg1 = (*C.PangoFontDescription)(gextras.StructNative(unsafe.Pointer(desc)))

	_cret = C.pango_attr_font_desc_new(_arg1)
	runtime.KeepAlive(desc)

	var _attribute *Attribute // out

	_attribute = (*Attribute)(gextras.NewStructNative(unsafe.Pointer(_cret)))
	runtime.SetFinalizer(
		gextras.StructIntern(unsafe.Pointer(_attribute)),
		func(intern *struct{ C unsafe.Pointer }) {
			C.pango_attribute_destroy((*C.PangoAttribute)(intern.C))
		},
	)

	return _attribute
}

// AttrInt: PangoAttrInt structure is used to represent attributes with an
// integer or enumeration value.
//
// An instance of this type is always passed by reference.
type AttrInt struct {
	*attrInt
}

// attrInt is the struct that's finalized.
type attrInt struct {
	native *C.PangoAttrInt
}

// Attr: common portion of the attribute.
func (a *AttrInt) Attr() *Attribute {
	valptr := &a.native.attr
	var _v *Attribute // out
	_v = (*Attribute)(gextras.NewStructNative(unsafe.Pointer(valptr)))
	return _v
}

// Value: value of the attribute.
func (a *AttrInt) Value() int {
	valptr := &a.native.value
	var _v int // out
	_v = int(*valptr)
	return _v
}

// Value: value of the attribute.
func (a *AttrInt) SetValue(value int) {
	valptr := &a.native.value
	*valptr = C.int(value)
}

// AttrIterator: PangoAttrIterator is used to iterate through a PangoAttrList.
//
// A new iterator is created with pango.AttrList.GetIterator(). Once the
// iterator is created, it can be advanced through the style changes in the text
// using pango.AttrIterator.Next(). At each style change, the range of the
// current style segment and the attributes currently in effect can be queried.
//
// An instance of this type is always passed by reference.
type AttrIterator struct {
	*attrIterator
}

// attrIterator is the struct that's finalized.
type attrIterator struct {
	native *C.PangoAttrIterator
}

func marshalAttrIterator(p uintptr) (interface{}, error) {
	b := coreglib.ValueFromNative(unsafe.Pointer(p)).Boxed()
	return &AttrIterator{&attrIterator{(*C.PangoAttrIterator)(b)}}, nil
}

// Copy a PangoAttrIterator.
//
// The function returns the following values:
//
//    - attrIterator: newly allocated PangoAttrIterator, which should be freed
//      with pango.AttrIterator.Destroy().
//
func (iterator *AttrIterator) Copy() *AttrIterator {
	var _arg0 *C.PangoAttrIterator // out
	var _cret *C.PangoAttrIterator // in

	_arg0 = (*C.PangoAttrIterator)(gextras.StructNative(unsafe.Pointer(iterator)))

	_cret = C.pango_attr_iterator_copy(_arg0)
	runtime.KeepAlive(iterator)

	var _attrIterator *AttrIterator // out

	_attrIterator = (*AttrIterator)(gextras.NewStructNative(unsafe.Pointer(_cret)))
	runtime.SetFinalizer(
		gextras.StructIntern(unsafe.Pointer(_attrIterator)),
		func(intern *struct{ C unsafe.Pointer }) {
			C.pango_attr_iterator_destroy((*C.PangoAttrIterator)(intern.C))
		},
	)

	return _attrIterator
}

// Destroy a PangoAttrIterator and free all associated memory.
func (iterator *AttrIterator) Destroy() {
	var _arg0 *C.PangoAttrIterator // out

	_arg0 = (*C.PangoAttrIterator)(gextras.StructNative(unsafe.Pointer(iterator)))

	C.pango_attr_iterator_destroy(_arg0)
	runtime.KeepAlive(iterator)
}

// Get: find the current attribute of a particular type at the iterator
// location. When multiple attributes of the same type overlap, the attribute
// whose range starts closest to the current location is used.
//
// The function takes the following parameters:
//
//    - typ: type of attribute to find.
//
// The function returns the following values:
//
//    - attribute (optional): current attribute of the given type, or NULL if no
//      attribute of that type applies to the current location.
//
func (iterator *AttrIterator) Get(typ AttrType) *Attribute {
	var _arg0 *C.PangoAttrIterator // out
	var _arg1 C.PangoAttrType      // out
	var _cret *C.PangoAttribute    // in

	_arg0 = (*C.PangoAttrIterator)(gextras.StructNative(unsafe.Pointer(iterator)))
	_arg1 = C.PangoAttrType(typ)

	_cret = C.pango_attr_iterator_get(_arg0, _arg1)
	runtime.KeepAlive(iterator)
	runtime.KeepAlive(typ)

	var _attribute *Attribute // out

	if _cret != nil {
		_attribute = (*Attribute)(gextras.NewStructNative(unsafe.Pointer(_cret)))
	}

	return _attribute
}

// Attrs gets a list of all attributes at the current position of the iterator.
//
// The function returns the following values:
//
//    - sList: a list of all attributes for the current range. To free this
//      value, call pango.Attribute.Destroy() on each value and g_slist_free() on
//      the list.
//
func (iterator *AttrIterator) Attrs() []*Attribute {
	var _arg0 *C.PangoAttrIterator // out
	var _cret *C.GSList            // in

	_arg0 = (*C.PangoAttrIterator)(gextras.StructNative(unsafe.Pointer(iterator)))

	_cret = C.pango_attr_iterator_get_attrs(_arg0)
	runtime.KeepAlive(iterator)

	var _sList []*Attribute // out

	_sList = make([]*Attribute, 0, gextras.SListSize(unsafe.Pointer(_cret)))
	gextras.MoveSList(unsafe.Pointer(_cret), true, func(v unsafe.Pointer) {
		src := (*C.PangoAttribute)(v)
		var dst *Attribute // out
		dst = (*Attribute)(gextras.NewStructNative(unsafe.Pointer(src)))
		runtime.SetFinalizer(
			gextras.StructIntern(unsafe.Pointer(dst)),
			func(intern *struct{ C unsafe.Pointer }) {
				C.pango_attribute_destroy((*C.PangoAttribute)(intern.C))
			},
		)
		_sList = append(_sList, dst)
	})

	return _sList
}

// Next: advance the iterator until the next change of style.
//
// The function returns the following values:
//
//    - ok: FALSE if the iterator is at the end of the list, otherwise TRUE.
//
func (iterator *AttrIterator) Next() bool {
	var _arg0 *C.PangoAttrIterator // out
	var _cret C.gboolean           // in

	_arg0 = (*C.PangoAttrIterator)(gextras.StructNative(unsafe.Pointer(iterator)))

	_cret = C.pango_attr_iterator_next(_arg0)
	runtime.KeepAlive(iterator)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// Range: get the range of the current segment. Note that the stored return
// values are signed, not unsigned like the values in PangoAttribute. To deal
// with this API oversight, stored return values that wouldn't fit into a signed
// integer are clamped to G_MAXINT.
//
// The function returns the following values:
//
//    - start: location to store the start of the range.
//    - end: location to store the end of the range.
//
func (iterator *AttrIterator) Range() (start int, end int) {
	var _arg0 *C.PangoAttrIterator // out
	var _arg1 C.gint               // in
	var _arg2 C.gint               // in

	_arg0 = (*C.PangoAttrIterator)(gextras.StructNative(unsafe.Pointer(iterator)))

	C.pango_attr_iterator_range(_arg0, &_arg1, &_arg2)
	runtime.KeepAlive(iterator)

	var _start int // out
	var _end int   // out

	_start = int(_arg1)
	_end = int(_arg2)

	return _start, _end
}

// AttrLanguage: PangoAttrLanguage structure is used to represent attributes
// that are languages.
//
// An instance of this type is always passed by reference.
type AttrLanguage struct {
	*attrLanguage
}

// attrLanguage is the struct that's finalized.
type attrLanguage struct {
	native *C.PangoAttrLanguage
}

// Attr: common portion of the attribute.
func (a *AttrLanguage) Attr() *Attribute {
	valptr := &a.native.attr
	var _v *Attribute // out
	_v = (*Attribute)(gextras.NewStructNative(unsafe.Pointer(valptr)))
	return _v
}

// Value: PangoLanguage which is the value of the attribute.
func (a *AttrLanguage) Value() *Language {
	valptr := &a.native.value
	var _v *Language // out
	_v = (*Language)(gextras.NewStructNative(unsafe.Pointer(*valptr)))
	return _v
}

// NewAttrLanguage: create a new language tag attribute.
//
// The function takes the following parameters:
//
//    - language tag.
//
// The function returns the following values:
//
//    - attribute: newly allocated PangoAttribute, which should be freed with
//      pango.Attribute.Destroy().
//
func NewAttrLanguage(language *Language) *Attribute {
	var _arg1 *C.PangoLanguage  // out
	var _cret *C.PangoAttribute // in

	_arg1 = (*C.PangoLanguage)(gextras.StructNative(unsafe.Pointer(language)))

	_cret = C.pango_attr_language_new(_arg1)
	runtime.KeepAlive(language)

	var _attribute *Attribute // out

	_attribute = (*Attribute)(gextras.NewStructNative(unsafe.Pointer(_cret)))
	runtime.SetFinalizer(
		gextras.StructIntern(unsafe.Pointer(_attribute)),
		func(intern *struct{ C unsafe.Pointer }) {
			C.pango_attribute_destroy((*C.PangoAttribute)(intern.C))
		},
	)

	return _attribute
}

// AttrList: PangoAttrList represents a list of attributes that apply to a
// section of text.
//
// The attributes in a PangoAttrList are, in general, allowed to overlap in an
// arbitrary fashion. However, if the attributes are manipulated only through
// pango.AttrList.Change(), the overlap between properties will meet stricter
// criteria.
//
// Since the PangoAttrList structure is stored as a linear list, it is not
// suitable for storing attributes for large amounts of text. In general, you
// should not use a single PangoAttrList for more than one paragraph of text.
//
// An instance of this type is always passed by reference.
type AttrList struct {
	*attrList
}

// attrList is the struct that's finalized.
type attrList struct {
	native *C.PangoAttrList
}

func marshalAttrList(p uintptr) (interface{}, error) {
	b := coreglib.ValueFromNative(unsafe.Pointer(p)).Boxed()
	return &AttrList{&attrList{(*C.PangoAttrList)(b)}}, nil
}

// NewAttrList constructs a struct AttrList.
func NewAttrList() *AttrList {
	var _cret *C.PangoAttrList // in

	_cret = C.pango_attr_list_new()

	var _attrList *AttrList // out

	_attrList = (*AttrList)(gextras.NewStructNative(unsafe.Pointer(_cret)))
	runtime.SetFinalizer(
		gextras.StructIntern(unsafe.Pointer(_attrList)),
		func(intern *struct{ C unsafe.Pointer }) {
			C.pango_attr_list_unref((*C.PangoAttrList)(intern.C))
		},
	)

	return _attrList
}

// Change: insert the given attribute into the PangoAttrList.
//
// It will replace any attributes of the same type on that segment and be merged
// with any adjoining attributes that are identical.
//
// This function is slower than pango.AttrList.Insert() for creating an
// attribute list in order (potentially much slower for large lists). However,
// pango.AttrList.Insert() is not suitable for continually changing a set of
// attributes since it never removes or combines existing attributes.
//
// The function takes the following parameters:
//
//    - attr: attribute to insert. Ownership of this value is assumed by the
//      list.
//
func (list *AttrList) Change(attr *Attribute) {
	var _arg0 *C.PangoAttrList  // out
	var _arg1 *C.PangoAttribute // out

	_arg0 = (*C.PangoAttrList)(gextras.StructNative(unsafe.Pointer(list)))
	_arg1 = (*C.PangoAttribute)(gextras.StructNative(unsafe.Pointer(attr)))
	runtime.SetFinalizer(gextras.StructIntern(unsafe.Pointer(attr)), nil)

	C.pango_attr_list_change(_arg0, _arg1)
	runtime.KeepAlive(list)
	runtime.KeepAlive(attr)
}

// Copy list and return an identical new list.
//
// The function returns the following values:
//
//    - attrList (optional): newly allocated PangoAttrList, with a reference
//      count of one, which should be freed with pango.AttrList.Unref(). Returns
//      NULL if list was NULL.
//
func (list *AttrList) Copy() *AttrList {
	var _arg0 *C.PangoAttrList // out
	var _cret *C.PangoAttrList // in

	if list != nil {
		_arg0 = (*C.PangoAttrList)(gextras.StructNative(unsafe.Pointer(list)))
	}

	_cret = C.pango_attr_list_copy(_arg0)
	runtime.KeepAlive(list)

	var _attrList *AttrList // out

	if _cret != nil {
		_attrList = (*AttrList)(gextras.NewStructNative(unsafe.Pointer(_cret)))
		runtime.SetFinalizer(
			gextras.StructIntern(unsafe.Pointer(_attrList)),
			func(intern *struct{ C unsafe.Pointer }) {
				C.pango_attr_list_unref((*C.PangoAttrList)(intern.C))
			},
		)
	}

	return _attrList
}

// Equal checks whether list and other_list contain the same attributes and
// whether those attributes apply to the same ranges. Beware that this will
// return wrong values if any list contains duplicates.
//
// The function takes the following parameters:
//
//    - otherList: other PangoAttrList.
//
// The function returns the following values:
//
//    - ok: TRUE if the lists are equal, FALSE if they aren't.
//
func (list *AttrList) Equal(otherList *AttrList) bool {
	var _arg0 *C.PangoAttrList // out
	var _arg1 *C.PangoAttrList // out
	var _cret C.gboolean       // in

	_arg0 = (*C.PangoAttrList)(gextras.StructNative(unsafe.Pointer(list)))
	_arg1 = (*C.PangoAttrList)(gextras.StructNative(unsafe.Pointer(otherList)))

	_cret = C.pango_attr_list_equal(_arg0, _arg1)
	runtime.KeepAlive(list)
	runtime.KeepAlive(otherList)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// Filter: given a PangoAttrList and callback function, removes any elements of
// list for which func returns TRUE and inserts them into a new list.
//
// The function takes the following parameters:
//
//    - fn: callback function; returns TRUE if an attribute should be filtered
//      out.
//
// The function returns the following values:
//
//    - attrList (optional): new PangoAttrList or NULL if no attributes of the
//      given types were found.
//
func (list *AttrList) Filter(fn AttrFilterFunc) *AttrList {
	var _arg0 *C.PangoAttrList      // out
	var _arg1 C.PangoAttrFilterFunc // out
	var _arg2 C.gpointer
	var _cret *C.PangoAttrList // in

	_arg0 = (*C.PangoAttrList)(gextras.StructNative(unsafe.Pointer(list)))
	_arg1 = (*[0]byte)(C._gotk4_pango1_AttrFilterFunc)
	_arg2 = C.gpointer(gbox.Assign(fn))
	defer gbox.Delete(uintptr(_arg2))

	_cret = C.pango_attr_list_filter(_arg0, _arg1, _arg2)
	runtime.KeepAlive(list)
	runtime.KeepAlive(fn)

	var _attrList *AttrList // out

	if _cret != nil {
		_attrList = (*AttrList)(gextras.NewStructNative(unsafe.Pointer(_cret)))
		runtime.SetFinalizer(
			gextras.StructIntern(unsafe.Pointer(_attrList)),
			func(intern *struct{ C unsafe.Pointer }) {
				C.pango_attr_list_unref((*C.PangoAttrList)(intern.C))
			},
		)
	}

	return _attrList
}

// Attributes gets a list of all attributes in list.
//
// The function returns the following values:
//
//    - sList: a list of all attributes in list. To free this value, call
//      pango.Attribute.Destroy on each value and g_slist_free() on the list.
//
func (list *AttrList) Attributes() []*Attribute {
	var _arg0 *C.PangoAttrList // out
	var _cret *C.GSList        // in

	_arg0 = (*C.PangoAttrList)(gextras.StructNative(unsafe.Pointer(list)))

	_cret = C.pango_attr_list_get_attributes(_arg0)
	runtime.KeepAlive(list)

	var _sList []*Attribute // out

	_sList = make([]*Attribute, 0, gextras.SListSize(unsafe.Pointer(_cret)))
	gextras.MoveSList(unsafe.Pointer(_cret), true, func(v unsafe.Pointer) {
		src := (*C.PangoAttribute)(v)
		var dst *Attribute // out
		dst = (*Attribute)(gextras.NewStructNative(unsafe.Pointer(src)))
		runtime.SetFinalizer(
			gextras.StructIntern(unsafe.Pointer(dst)),
			func(intern *struct{ C unsafe.Pointer }) {
				C.pango_attribute_destroy((*C.PangoAttribute)(intern.C))
			},
		)
		_sList = append(_sList, dst)
	})

	return _sList
}

// Iterator: create a iterator initialized to the beginning of the list. list
// must not be modified until this iterator is freed.
//
// The function returns the following values:
//
//    - attrIterator: newly allocated PangoAttrIterator, which should be freed
//      with pango.AttrIterator.Destroy().
//
func (list *AttrList) Iterator() *AttrIterator {
	var _arg0 *C.PangoAttrList     // out
	var _cret *C.PangoAttrIterator // in

	_arg0 = (*C.PangoAttrList)(gextras.StructNative(unsafe.Pointer(list)))

	_cret = C.pango_attr_list_get_iterator(_arg0)
	runtime.KeepAlive(list)

	var _attrIterator *AttrIterator // out

	_attrIterator = (*AttrIterator)(gextras.NewStructNative(unsafe.Pointer(_cret)))
	runtime.SetFinalizer(
		gextras.StructIntern(unsafe.Pointer(_attrIterator)),
		func(intern *struct{ C unsafe.Pointer }) {
			C.pango_attr_iterator_destroy((*C.PangoAttrIterator)(intern.C))
		},
	)

	return _attrIterator
}

// Insert the given attribute into the PangoAttrList.
//
// It will be inserted after all other attributes with a matching start_index.
//
// The function takes the following parameters:
//
//    - attr: attribute to insert. Ownership of this value is assumed by the
//      list.
//
func (list *AttrList) Insert(attr *Attribute) {
	var _arg0 *C.PangoAttrList  // out
	var _arg1 *C.PangoAttribute // out

	_arg0 = (*C.PangoAttrList)(gextras.StructNative(unsafe.Pointer(list)))
	_arg1 = (*C.PangoAttribute)(gextras.StructNative(unsafe.Pointer(attr)))
	runtime.SetFinalizer(gextras.StructIntern(unsafe.Pointer(attr)), nil)

	C.pango_attr_list_insert(_arg0, _arg1)
	runtime.KeepAlive(list)
	runtime.KeepAlive(attr)
}

// InsertBefore: insert the given attribute into the PangoAttrList.
//
// It will be inserted before all other attributes with a matching start_index.
//
// The function takes the following parameters:
//
//    - attr: attribute to insert. Ownership of this value is assumed by the
//      list.
//
func (list *AttrList) InsertBefore(attr *Attribute) {
	var _arg0 *C.PangoAttrList  // out
	var _arg1 *C.PangoAttribute // out

	_arg0 = (*C.PangoAttrList)(gextras.StructNative(unsafe.Pointer(list)))
	_arg1 = (*C.PangoAttribute)(gextras.StructNative(unsafe.Pointer(attr)))
	runtime.SetFinalizer(gextras.StructIntern(unsafe.Pointer(attr)), nil)

	C.pango_attr_list_insert_before(_arg0, _arg1)
	runtime.KeepAlive(list)
	runtime.KeepAlive(attr)
}

// Splice: this function opens up a hole in list, fills it in with attributes
// from the left, and then merges other on top of the hole.
//
// This operation is equivalent to stretching every attribute that applies at
// position pos in list by an amount len, and then calling
// pango.AttrList.Change() with a copy of each attribute in other in sequence
// (offset in position by pos).
//
// This operation proves useful for, for instance, inserting a pre-edit string
// in the middle of an edit buffer.
//
// The function takes the following parameters:
//
//    - other PangoAttrList.
//    - pos: position in list at which to insert other.
//    - len: length of the spliced segment. (Note that this must be specified
//      since the attributes in other may only be present at some subsection of
//      this range).
//
func (list *AttrList) Splice(other *AttrList, pos int, len int) {
	var _arg0 *C.PangoAttrList // out
	var _arg1 *C.PangoAttrList // out
	var _arg2 C.gint           // out
	var _arg3 C.gint           // out

	_arg0 = (*C.PangoAttrList)(gextras.StructNative(unsafe.Pointer(list)))
	_arg1 = (*C.PangoAttrList)(gextras.StructNative(unsafe.Pointer(other)))
	_arg2 = C.gint(pos)
	_arg3 = C.gint(len)

	C.pango_attr_list_splice(_arg0, _arg1, _arg2, _arg3)
	runtime.KeepAlive(list)
	runtime.KeepAlive(other)
	runtime.KeepAlive(pos)
	runtime.KeepAlive(len)
}

// Update indices of attributes in list for a change in the text they refer to.
//
// The change that this function applies is removing remove bytes at position
// pos and inserting add bytes instead.
//
// Attributes that fall entirely in the (pos, pos + remove) range are removed.
//
// Attributes that start or end inside the (pos, pos + remove) range are
// shortened to reflect the removal.
//
// Attributes start and end positions are updated if they are behind pos +
// remove.
//
// The function takes the following parameters:
//
//    - pos: position of the change.
//    - remove: number of removed bytes.
//    - add: number of added bytes.
//
func (list *AttrList) Update(pos int, remove int, add int) {
	var _arg0 *C.PangoAttrList // out
	var _arg1 C.int            // out
	var _arg2 C.int            // out
	var _arg3 C.int            // out

	_arg0 = (*C.PangoAttrList)(gextras.StructNative(unsafe.Pointer(list)))
	_arg1 = C.int(pos)
	_arg2 = C.int(remove)
	_arg3 = C.int(add)

	C.pango_attr_list_update(_arg0, _arg1, _arg2, _arg3)
	runtime.KeepAlive(list)
	runtime.KeepAlive(pos)
	runtime.KeepAlive(remove)
	runtime.KeepAlive(add)
}

// AttrShape: PangoAttrShape structure is used to represent attributes which
// impose shape restrictions.
//
// An instance of this type is always passed by reference.
type AttrShape struct {
	*attrShape
}

// attrShape is the struct that's finalized.
type attrShape struct {
	native *C.PangoAttrShape
}

// NewAttrShape: create a new shape attribute.
//
// A shape is used to impose a particular ink and logical rectangle on the
// result of shaping a particular glyph. This might be used, for instance, for
// embedding a picture or a widget inside a PangoLayout.
//
// The function takes the following parameters:
//
//    - inkRect: ink rectangle to assign to each character.
//    - logicalRect: logical rectangle to assign to each character.
//
// The function returns the following values:
//
//    - attribute: newly allocated PangoAttribute, which should be freed with
//      pango.Attribute.Destroy().
//
func NewAttrShape(inkRect, logicalRect *Rectangle) *Attribute {
	var _arg1 *C.PangoRectangle // out
	var _arg2 *C.PangoRectangle // out
	var _cret *C.PangoAttribute // in

	_arg1 = (*C.PangoRectangle)(gextras.StructNative(unsafe.Pointer(inkRect)))
	_arg2 = (*C.PangoRectangle)(gextras.StructNative(unsafe.Pointer(logicalRect)))

	_cret = C.pango_attr_shape_new(_arg1, _arg2)
	runtime.KeepAlive(inkRect)
	runtime.KeepAlive(logicalRect)

	var _attribute *Attribute // out

	_attribute = (*Attribute)(gextras.NewStructNative(unsafe.Pointer(_cret)))
	runtime.SetFinalizer(
		gextras.StructIntern(unsafe.Pointer(_attribute)),
		func(intern *struct{ C unsafe.Pointer }) {
			C.pango_attribute_destroy((*C.PangoAttribute)(intern.C))
		},
	)

	return _attribute
}

// AttrSize: PangoAttrSize structure is used to represent attributes which set
// font size.
//
// An instance of this type is always passed by reference.
type AttrSize struct {
	*attrSize
}

// attrSize is the struct that's finalized.
type attrSize struct {
	native *C.PangoAttrSize
}

// Attr: common portion of the attribute.
func (a *AttrSize) Attr() *Attribute {
	valptr := &a.native.attr
	var _v *Attribute // out
	_v = (*Attribute)(gextras.NewStructNative(unsafe.Pointer(valptr)))
	return _v
}

// Size: size of font, in units of 1/PANGO_SCALE of a point (for
// PANGO_ATTR_SIZE) or of a device unit (for PANGO_ATTR_ABSOLUTE_SIZE).
func (a *AttrSize) Size() int {
	valptr := &a.native.size
	var _v int // out
	_v = int(*valptr)
	return _v
}

// Size: size of font, in units of 1/PANGO_SCALE of a point (for
// PANGO_ATTR_SIZE) or of a device unit (for PANGO_ATTR_ABSOLUTE_SIZE).
func (a *AttrSize) SetSize(size int) {
	valptr := &a.native.size
	*valptr = C.int(size)
}

// NewAttrSize: create a new font-size attribute in fractional points.
//
// The function takes the following parameters:
//
//    - size: font size, in PANGO_SCALEths of a point.
//
// The function returns the following values:
//
//    - attribute: newly allocated PangoAttribute, which should be freed with
//      pango.Attribute.Destroy().
//
func NewAttrSize(size int) *Attribute {
	var _arg1 C.int             // out
	var _cret *C.PangoAttribute // in

	_arg1 = C.int(size)

	_cret = C.pango_attr_size_new(_arg1)
	runtime.KeepAlive(size)

	var _attribute *Attribute // out

	_attribute = (*Attribute)(gextras.NewStructNative(unsafe.Pointer(_cret)))
	runtime.SetFinalizer(
		gextras.StructIntern(unsafe.Pointer(_attribute)),
		func(intern *struct{ C unsafe.Pointer }) {
			C.pango_attribute_destroy((*C.PangoAttribute)(intern.C))
		},
	)

	return _attribute
}

// AttrString: PangoAttrString structure is used to represent attributes with a
// string value.
//
// An instance of this type is always passed by reference.
type AttrString struct {
	*attrString
}

// attrString is the struct that's finalized.
type attrString struct {
	native *C.PangoAttrString
}

// Attr: common portion of the attribute.
func (a *AttrString) Attr() *Attribute {
	valptr := &a.native.attr
	var _v *Attribute // out
	_v = (*Attribute)(gextras.NewStructNative(unsafe.Pointer(valptr)))
	return _v
}

// Value: string which is the value of the attribute.
func (a *AttrString) Value() string {
	valptr := &a.native.value
	var _v string // out
	_v = C.GoString((*C.gchar)(unsafe.Pointer(*valptr)))
	return _v
}

// Attribute: PangoAttribute structure represents the common portions of all
// attributes.
//
// Particular types of attributes include this structure as their initial
// portion. The common portion of the attribute holds the range to which the
// value in the type-specific part of the attribute applies and should be
// initialized using pango.Attribute.Init(). By default, an attribute will have
// an all-inclusive range of [0,G_MAXUINT].
//
// An instance of this type is always passed by reference.
type Attribute struct {
	*attribute
}

// attribute is the struct that's finalized.
type attribute struct {
	native *C.PangoAttribute
}

func marshalAttribute(p uintptr) (interface{}, error) {
	b := coreglib.ValueFromNative(unsafe.Pointer(p)).Boxed()
	return &Attribute{&attribute{(*C.PangoAttribute)(b)}}, nil
}

// Klass class structure holding information about the type of the attribute.
func (a *Attribute) Klass() *AttrClass {
	valptr := &a.native.klass
	var _v *AttrClass // out
	_v = (*AttrClass)(gextras.NewStructNative(unsafe.Pointer(*valptr)))
	return _v
}

// StartIndex: start index of the range (in bytes).
func (a *Attribute) StartIndex() uint {
	valptr := &a.native.start_index
	var _v uint // out
	_v = uint(*valptr)
	return _v
}

// EndIndex: end index of the range (in bytes). The character at this index is
// not included in the range.
func (a *Attribute) EndIndex() uint {
	valptr := &a.native.end_index
	var _v uint // out
	_v = uint(*valptr)
	return _v
}

// StartIndex: start index of the range (in bytes).
func (a *Attribute) SetStartIndex(startIndex uint) {
	valptr := &a.native.start_index
	*valptr = C.guint(startIndex)
}

// EndIndex: end index of the range (in bytes). The character at this index is
// not included in the range.
func (a *Attribute) SetEndIndex(endIndex uint) {
	valptr := &a.native.end_index
	*valptr = C.guint(endIndex)
}

// Copy: make a copy of an attribute.
//
// The function returns the following values:
//
//    - attribute: newly allocated PangoAttribute, which should be freed with
//      pango.Attribute.Destroy().
//
func (attr *Attribute) Copy() *Attribute {
	var _arg0 *C.PangoAttribute // out
	var _cret *C.PangoAttribute // in

	_arg0 = (*C.PangoAttribute)(gextras.StructNative(unsafe.Pointer(attr)))

	_cret = C.pango_attribute_copy(_arg0)
	runtime.KeepAlive(attr)

	var _attribute *Attribute // out

	_attribute = (*Attribute)(gextras.NewStructNative(unsafe.Pointer(_cret)))
	runtime.SetFinalizer(
		gextras.StructIntern(unsafe.Pointer(_attribute)),
		func(intern *struct{ C unsafe.Pointer }) {
			C.pango_attribute_destroy((*C.PangoAttribute)(intern.C))
		},
	)

	return _attribute
}

// Destroy a PangoAttribute and free all associated memory.
func (attr *Attribute) Destroy() {
	var _arg0 *C.PangoAttribute // out

	_arg0 = (*C.PangoAttribute)(gextras.StructNative(unsafe.Pointer(attr)))

	C.pango_attribute_destroy(_arg0)
	runtime.KeepAlive(attr)
}

// Equal: compare two attributes for equality. This compares only the actual
// value of the two attributes and not the ranges that the attributes apply to.
//
// The function takes the following parameters:
//
//    - attr2: another PangoAttribute.
//
// The function returns the following values:
//
//    - ok: TRUE if the two attributes have the same value.
//
func (attr1 *Attribute) Equal(attr2 *Attribute) bool {
	var _arg0 *C.PangoAttribute // out
	var _arg1 *C.PangoAttribute // out
	var _cret C.gboolean        // in

	_arg0 = (*C.PangoAttribute)(gextras.StructNative(unsafe.Pointer(attr1)))
	_arg1 = (*C.PangoAttribute)(gextras.StructNative(unsafe.Pointer(attr2)))

	_cret = C.pango_attribute_equal(_arg0, _arg1)
	runtime.KeepAlive(attr1)
	runtime.KeepAlive(attr2)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// Init initializes attr's klass to klass, it's start_index to
// PANGO_ATTR_INDEX_FROM_TEXT_BEGINNING and end_index to
// PANGO_ATTR_INDEX_TO_TEXT_END such that the attribute applies to the entire
// text by default.
//
// The function takes the following parameters:
//
//    - klass: PangoAttrClass.
//
func (attr *Attribute) Init(klass *AttrClass) {
	var _arg0 *C.PangoAttribute // out
	var _arg1 *C.PangoAttrClass // out

	_arg0 = (*C.PangoAttribute)(gextras.StructNative(unsafe.Pointer(attr)))
	_arg1 = (*C.PangoAttrClass)(gextras.StructNative(unsafe.Pointer(klass)))

	C.pango_attribute_init(_arg0, _arg1)
	runtime.KeepAlive(attr)
	runtime.KeepAlive(klass)
}

// Color: PangoColor structure is used to represent a color in an uncalibrated
// RGB color-space.
//
// An instance of this type is always passed by reference.
type Color struct {
	*color
}

// color is the struct that's finalized.
type color struct {
	native *C.PangoColor
}

func marshalColor(p uintptr) (interface{}, error) {
	b := coreglib.ValueFromNative(unsafe.Pointer(p)).Boxed()
	return &Color{&color{(*C.PangoColor)(b)}}, nil
}

// NewColor creates a new Color instance from the given
// fields. Beware that this function allocates on the Go heap; be careful
// when using it!
func NewColor(red, green, blue uint16) Color {
	var f0 C.guint16 // out
	f0 = C.guint16(red)
	var f1 C.guint16 // out
	f1 = C.guint16(green)
	var f2 C.guint16 // out
	f2 = C.guint16(blue)

	v := C.PangoColor{
		red:   f0,
		green: f1,
		blue:  f2,
	}

	return *(*Color)(gextras.NewStructNative(unsafe.Pointer(&v)))
}

// Red: value of red component.
func (c *Color) Red() uint16 {
	valptr := &c.native.red
	var _v uint16 // out
	_v = uint16(*valptr)
	return _v
}

// Green: value of green component.
func (c *Color) Green() uint16 {
	valptr := &c.native.green
	var _v uint16 // out
	_v = uint16(*valptr)
	return _v
}

// Blue: value of blue component.
func (c *Color) Blue() uint16 {
	valptr := &c.native.blue
	var _v uint16 // out
	_v = uint16(*valptr)
	return _v
}

// Red: value of red component.
func (c *Color) SetRed(red uint16) {
	valptr := &c.native.red
	*valptr = C.guint16(red)
}

// Green: value of green component.
func (c *Color) SetGreen(green uint16) {
	valptr := &c.native.green
	*valptr = C.guint16(green)
}

// Blue: value of blue component.
func (c *Color) SetBlue(blue uint16) {
	valptr := &c.native.blue
	*valptr = C.guint16(blue)
}

// Copy creates a copy of src.
//
// The copy should be freed with pango_color_free(). Primarily used by language
// bindings, not that useful otherwise (since colors can just be copied by
// assignment in C).
//
// The function returns the following values:
//
//    - color (optional): newly allocated PangoColor, which should be freed with
//      pango.Color.Free(), or NULL if src was NULL.
//
func (src *Color) Copy() *Color {
	var _arg0 *C.PangoColor // out
	var _cret *C.PangoColor // in

	if src != nil {
		_arg0 = (*C.PangoColor)(gextras.StructNative(unsafe.Pointer(src)))
	}

	_cret = C.pango_color_copy(_arg0)
	runtime.KeepAlive(src)

	var _color *Color // out

	if _cret != nil {
		_color = (*Color)(gextras.NewStructNative(unsafe.Pointer(_cret)))
		runtime.SetFinalizer(
			gextras.StructIntern(unsafe.Pointer(_color)),
			func(intern *struct{ C unsafe.Pointer }) {
				C.pango_color_free((*C.PangoColor)(intern.C))
			},
		)
	}

	return _color
}

// Parse: fill in the fields of a color from a string specification.
//
// The string can either one of a large set of standard names. (Taken from the
// CSS Color specification (https://www.w3.org/TR/css-color-4/#named-colors), or
// it can be a value in the form #rgb, #rrggbb, #rrrgggbbb or #rrrrggggbbbb,
// where r, g and b are hex digits of the red, green, and blue components of the
// color, respectively. (White in the four forms is #fff, #ffffff, #fffffffff
// and #ffffffffffff.).
//
// The function takes the following parameters:
//
//    - spec: string specifying the new color.
//
// The function returns the following values:
//
//    - ok: TRUE if parsing of the specifier succeeded, otherwise false.
//
func (color *Color) Parse(spec string) bool {
	var _arg0 *C.PangoColor // out
	var _arg1 *C.char       // out
	var _cret C.gboolean    // in

	if color != nil {
		_arg0 = (*C.PangoColor)(gextras.StructNative(unsafe.Pointer(color)))
	}
	_arg1 = (*C.char)(unsafe.Pointer(C.CString(spec)))
	defer C.free(unsafe.Pointer(_arg1))

	_cret = C.pango_color_parse(_arg0, _arg1)
	runtime.KeepAlive(color)
	runtime.KeepAlive(spec)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// ParseWithAlpha: fill in the fields of a color from a string specification.
//
// The string can either one of a large set of standard names. (Taken from the
// CSS Color specification (https://www.w3.org/TR/css-color-4/#named-colors), or
// it can be a hexadecimal value in the form #rgb, #rrggbb, #rrrgggbbb or
// #rrrrggggbbbb where r, g and b are hex digits of the red, green, and blue
// components of the color, respectively. (White in the four forms is #fff,
// #ffffff, #fffffffff and #ffffffffffff.)
//
// Additionally, parse strings of the form #rgba, #rrggbbaa, #rrrrggggbbbbaaaa,
// if alpha is not NULL, and set alpha to the value specified by the hex digits
// for a. If no alpha component is found in spec, alpha is set to 0xffff (for a
// solid color).
//
// The function takes the following parameters:
//
//    - spec: string specifying the new color.
//
// The function returns the following values:
//
//    - alpha (optional): return location for alpha, or NULL.
//    - ok: TRUE if parsing of the specifier succeeded, otherwise false.
//
func (color *Color) ParseWithAlpha(spec string) (uint16, bool) {
	var _arg0 *C.PangoColor // out
	var _arg1 C.guint16     // in
	var _arg2 *C.char       // out
	var _cret C.gboolean    // in

	if color != nil {
		_arg0 = (*C.PangoColor)(gextras.StructNative(unsafe.Pointer(color)))
	}
	_arg2 = (*C.char)(unsafe.Pointer(C.CString(spec)))
	defer C.free(unsafe.Pointer(_arg2))

	_cret = C.pango_color_parse_with_alpha(_arg0, &_arg1, _arg2)
	runtime.KeepAlive(color)
	runtime.KeepAlive(spec)

	var _alpha uint16 // out
	var _ok bool      // out

	_alpha = uint16(_arg1)
	if _cret != 0 {
		_ok = true
	}

	return _alpha, _ok
}

// String returns a textual specification of color.
//
// The string is in the hexadecimal form #rrrrggggbbbb, where r, g and b are hex
// digits representing the red, green, and blue components respectively.
//
// The function returns the following values:
//
//    - utf8: newly-allocated text string that must be freed with g_free().
//
func (color *Color) String() string {
	var _arg0 *C.PangoColor // out
	var _cret *C.gchar      // in

	_arg0 = (*C.PangoColor)(gextras.StructNative(unsafe.Pointer(color)))

	_cret = C.pango_color_to_string(_arg0)
	runtime.KeepAlive(color)

	var _utf8 string // out

	_utf8 = C.GoString((*C.gchar)(unsafe.Pointer(_cret)))
	defer C.free(unsafe.Pointer(_cret))

	return _utf8
}
