// Code generated by girgen. DO NOT EDIT.

package pango

import (
	"fmt"
	"runtime"
	"unsafe"

	"github.com/diamondburned/gotk4/pkg/core/gextras"
	coreglib "github.com/diamondburned/gotk4/pkg/core/glib"
)

// #include <stdlib.h>
// #include <glib-object.h>
// #include <pango/pango.h>
import "C"

// GType values.
var (
	GTypeGravity     = coreglib.Type(C.pango_gravity_get_type())
	GTypeGravityHint = coreglib.Type(C.pango_gravity_hint_get_type())
)

func init() {
	coreglib.RegisterGValueMarshalers([]coreglib.TypeMarshaler{
		coreglib.TypeMarshaler{T: GTypeGravity, F: marshalGravity},
		coreglib.TypeMarshaler{T: GTypeGravityHint, F: marshalGravityHint},
	})
}

// Gravity: PangoGravity represents the orientation of glyphs in a segment of
// text.
//
// This is useful when rendering vertical text layouts. In those situations, the
// layout is rotated using a non-identity pango.Matrix, and then glyph
// orientation is controlled using PangoGravity.
//
// Not every value in this enumeration makes sense for every usage of
// PangoGravity; for example, PANGO_GRAVITY_AUTO only can be passed to
// pango.Context.SetBaseGravity() and can only be returned by
// pango.Context.GetBaseGravity().
//
// See also: pango.GravityHint.
type Gravity C.gint

const (
	// GravitySouth glyphs stand upright (default).
	GravitySouth Gravity = iota
	// GravityEast glyphs are rotated 90 degrees clockwise.
	GravityEast
	// GravityNorth glyphs are upside-down.
	GravityNorth
	// GravityWest glyphs are rotated 90 degrees counter-clockwise.
	GravityWest
	// GravityAuto: gravity is resolved from the context matrix.
	GravityAuto
)

func marshalGravity(p uintptr) (interface{}, error) {
	return Gravity(coreglib.ValueFromNative(unsafe.Pointer(p)).Enum()), nil
}

// String returns the name in string for Gravity.
func (g Gravity) String() string {
	switch g {
	case GravitySouth:
		return "South"
	case GravityEast:
		return "East"
	case GravityNorth:
		return "North"
	case GravityWest:
		return "West"
	case GravityAuto:
		return "Auto"
	default:
		return fmt.Sprintf("Gravity(%d)", g)
	}
}

// GravityGetForMatrix finds the gravity that best matches the rotation
// component in a PangoMatrix.
//
// The function takes the following parameters:
//
//    - matrix (optional): PangoMatrix.
//
// The function returns the following values:
//
//    - gravity of matrix, which will never be PANGO_GRAVITY_AUTO, or
//      PANGO_GRAVITY_SOUTH if matrix is NULL.
//
func GravityGetForMatrix(matrix *Matrix) Gravity {
	var _arg1 *C.PangoMatrix // out
	var _cret C.PangoGravity // in

	if matrix != nil {
		_arg1 = (*C.PangoMatrix)(gextras.StructNative(unsafe.Pointer(matrix)))
	}

	_cret = C.pango_gravity_get_for_matrix(_arg1)
	runtime.KeepAlive(matrix)

	var _gravity Gravity // out

	_gravity = Gravity(_cret)

	return _gravity
}

// GravityGetForScript returns the gravity to use in laying out a PangoItem.
//
// The gravity is determined based on the script, base gravity, and hint.
//
// If base_gravity is PANGO_GRAVITY_AUTO, it is first replaced with the
// preferred gravity of script. To get the preferred gravity of a script, pass
// PANGO_GRAVITY_AUTO and PANGO_GRAVITY_HINT_STRONG in.
//
// The function takes the following parameters:
//
//    - script to query.
//    - baseGravity: base gravity of the paragraph.
//    - hint: orientation hint.
//
// The function returns the following values:
//
//    - gravity: resolved gravity suitable to use for a run of text with script.
//
func GravityGetForScript(script Script, baseGravity Gravity, hint GravityHint) Gravity {
	var _arg1 C.PangoScript      // out
	var _arg2 C.PangoGravity     // out
	var _arg3 C.PangoGravityHint // out
	var _cret C.PangoGravity     // in

	_arg1 = C.PangoScript(script)
	_arg2 = C.PangoGravity(baseGravity)
	_arg3 = C.PangoGravityHint(hint)

	_cret = C.pango_gravity_get_for_script(_arg1, _arg2, _arg3)
	runtime.KeepAlive(script)
	runtime.KeepAlive(baseGravity)
	runtime.KeepAlive(hint)

	var _gravity Gravity // out

	_gravity = Gravity(_cret)

	return _gravity
}

// GravityToRotation converts a Gravity value to its natural rotation in
// radians.
//
// Note that pango.Matrix.Rotate() takes angle in degrees, not radians. So, to
// call pango.Matrix,rotate with the output of this function you should multiply
// it by (180. / G_PI).
//
// The function takes the following parameters:
//
//    - gravity to query, should not be PANGO_GRAVITY_AUTO.
//
// The function returns the following values:
//
//    - gdouble: rotation value corresponding to gravity.
//
func GravityToRotation(gravity Gravity) float64 {
	var _arg1 C.PangoGravity // out
	var _cret C.double       // in

	_arg1 = C.PangoGravity(gravity)

	_cret = C.pango_gravity_to_rotation(_arg1)
	runtime.KeepAlive(gravity)

	var _gdouble float64 // out

	_gdouble = float64(_cret)

	return _gdouble
}

// GravityHint: PangoGravityHint defines how horizontal scripts should behave in
// a vertical context.
//
// That is, English excerpts in a vertical paragraph for example.
//
// See also pango.Gravity.
type GravityHint C.gint

const (
	// GravityHintNatural scripts will take their natural gravity based on the
	// base gravity and the script. This is the default.
	GravityHintNatural GravityHint = iota
	// GravityHintStrong always use the base gravity set, regardless of the
	// script.
	GravityHintStrong
	// GravityHintLine: for scripts not in their natural direction (eg. Latin in
	// East gravity), choose per-script gravity such that every script respects
	// the line progression. This means, Latin and Arabic will take opposite
	// gravities and both flow top-to-bottom for example.
	GravityHintLine
)

func marshalGravityHint(p uintptr) (interface{}, error) {
	return GravityHint(coreglib.ValueFromNative(unsafe.Pointer(p)).Enum()), nil
}

// String returns the name in string for GravityHint.
func (g GravityHint) String() string {
	switch g {
	case GravityHintNatural:
		return "Natural"
	case GravityHintStrong:
		return "Strong"
	case GravityHintLine:
		return "Line"
	default:
		return fmt.Sprintf("GravityHint(%d)", g)
	}
}
